//BirefDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "BirefDlg.h"
#include "BkDoc.h"
#include "chromex.h"
#include "conrsdlg.h"
#include "CandibusDX.h"
#include "EurosmartDX.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBirefDlg dialog
CBirefDlg::CBirefDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBirefDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBirefDlg)
	m_sSigma1 = _T("");
	m_sSigma2 = _T("");
	m_s = _T("");
	m_sPasSigma = _T("");
	m_radioTypeScan = -1;
	m_sLambda1 = _T("");
	m_sLambda2 = _T("");
	//}}AFX_DATA_INIT
}
void CBirefDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBirefDlg)
	DDX_Control(pDX, IDC_PROGRES, m_progress);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDARRETER, m_btnArreter);
	DDX_Text(pDX, IDC_SIGMA1, m_sSigma1);
	DDX_Text(pDX, IDC_SIGMA2, m_sSigma2);
	DDX_Text(pDX, IDC_STATIC1, m_s);
	DDX_Text(pDX, IDC_PAS, m_sPasSigma);
	DDX_Radio(pDX, IDC_TYPE_SCAN, m_radioTypeScan);
	DDX_Text(pDX, IDC_STATIC_L11, m_sLambda1);
	DDX_Text(pDX, IDC_STATIC_L12, m_sLambda2);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CBirefDlg, CDialog)
	//{{AFX_MSG_MAP(CBirefDlg)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	ON_BN_CLICKED(IDARRETER, OnArreter)
	ON_WM_TIMER()
	ON_EN_CHANGE(IDC_SIGMA1, OnChangeSigma1)
	ON_EN_CHANGE(IDC_SIGMA2, OnChangeSigma2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CBirefDlg message handlers
void CBirefDlg::VerifPara(void)
{
	float 
		Lambda1,Lambda2,
		r;
	CString s;	                                 

	if (m_fSigma1<1) m_fSigma1=1;
	if (m_fSigma2<1) m_fSigma2=1;

	Lambda2=(float)(1E6/m_fSigma1);
	Lambda1=(float)(1E6/m_fSigma2);

	if (Lambda1<350) Lambda1=350;
	if (Lambda1>1100) Lambda1=1100;
	if (Lambda2<350) Lambda2=350;
	if (Lambda2>1100) Lambda2=1100;
	if (fabs(Lambda1-Lambda2)<1) Lambda2=Lambda1+1;
	if (Lambda2<Lambda1)
	{
		r=Lambda1;
		Lambda1=Lambda2;
		Lambda2=r;
	}                                             
	m_fSigma2=(float)(1E6/Lambda1);
	//2 chiffres aprs la virgule avec arrondi au plus prs
	s.Format("%1.2f",m_fSigma2);
	sscanf(s,"%f",&m_fSigma2);

	m_fSigma1=(float)(1E6/Lambda2);
	//2 chiffres aprs la virgule avec arrondi au plus prs
	s.Format("%1.2f",m_fSigma1);
	sscanf(s,"%f",&m_fSigma1);
	
	if (m_fPasSigma<0.01) m_fPasSigma=0.01;
	if (m_fPasSigma>m_fSigma2-m_fSigma1) m_fPasSigma=m_fSigma2-m_fSigma1;

	m_iNbA=(int)(1+(m_fSigma2-m_fSigma1)/m_fPasSigma);  
	if (m_iNbA>m_pDoc->m_iNbMax)
	{
		m_fPasSigma=(m_fSigma2-m_fSigma1)/(m_pDoc->m_iNbMax-1);	
		//2 chiffres aprs la virgule avec arrondi au plus prs
		s.Format("%1.2f",m_fPasSigma);
		sscanf(s,"%f",&m_fPasSigma);
	}
	m_iNbA=(int)(1+(m_fSigma2-m_fSigma1)/m_fPasSigma);  
}   
//__________________________________________________
void CBirefDlg::AffecteZ(void)
{
	m_sSigma1.Format("%1.2f",m_fSigma1);
	m_sSigma2.Format("%1.2f",m_fSigma2);
	m_sPasSigma.Format("%1.2f",m_fPasSigma);
	UpdateData(FALSE);
}
//__________________________________________________
void CBirefDlg::AffecteV(void)
{
	int i;
	float r;
	UpdateData(TRUE);
	i=sscanf(m_sSigma1,"%f",&r);if (i==1) m_fSigma1=r; else m_fSigma1=620; 
	i=sscanf(m_sSigma2,"%f",&r);if (i==1) m_fSigma2=r; else m_fSigma2=640;
	i=sscanf(m_sPasSigma,"%f",&r);if (i==1) m_fPasSigma=r; else m_fPasSigma=0.1;
}
//__________________________________________________
void CBirefDlg::OnOK() 
{
	//CDialog::OnOK();
}
//__________________________________________________
BOOL CBirefDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_iNo=m_pDoc->m_iNo;
	CString s;
	float
		u,lambda;
	int
		lfe,lfs;
	BOOL ok;

	m_fSigma1=m_pDoc->m_fSigma1;
	m_fSigma2=m_pDoc->m_fSigma2;
	m_fPasSigma=m_pDoc->m_fPasSigma;
	m_radioTypeScan=m_pDoc->m_radioTypeScan;
	VerifPara();
	m_sSigma1.Format("%1.2f",m_fSigma1);
	m_sSigma2.Format("%1.2f",m_fSigma2);
	m_sPasSigma.Format("%1.2f",m_fPasSigma);

	m_pCandi=new CCandibusDX();
	m_pEuro=new CEurosmartDX();
	switch (m_pApp->m_iTypeCarte)
	{
		case 0://Eurosmart
			u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,1);
			if (u==1e10)
			{
				m_s.Format("PROBLEME de lecture sur\ncarte Eurosmart !!");
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		case 1://Candibus
			u=m_pCandi->LitTension(m_pApp->m_radioVoie,1);
			if (u==1e10)
			{
				m_s.Format("PROBLEME de lecture sur\ncarte Candibus !!");
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		default:
			m_s.Format("Aucune carte A/N trouve !!\nAcquisitions simules...");
		break;
	}
	//Indicateur de progression, initialisation
	m_progress.SetRange(0,100);
	//Dure Timer
	m_iDuree=50;
	m_pApp->m_pChro->VideTampon();
	//Demande de configuration
	ok=m_pApp->m_pChro->WriteCom("QM\r");
	m_btnArreter.EnableWindow(FALSE);
	if (ok)
	{
		//Invalider tout...
		m_btnCancel.EnableWindow(FALSE);
		m_btnArreter.EnableWindow(FALSE);
		m_btnDemarrer.EnableWindow(FALSE);
		GetDlgItem(IDC_SIGMA1)->EnableWindow(FALSE);
		GetDlgItem(IDC_SIGMA2)->EnableWindow(FALSE);
		GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
		GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(FALSE);
		m_iNb=0;SetTimer(1,m_iDuree,NULL);
	}
	lambda=1e6/m_fSigma1;
	if (lambda>100 && lambda<1100)
		m_sLambda1.Format("(%1.2f nm)",lambda);
	else
		m_sLambda1.Format("(? nm)");
	lambda=1e6/m_fSigma2;
	if (lambda>100 && lambda<1100)
		m_sLambda2.Format("(%1.2f nm)",lambda);
	else
		m_sLambda2.Format("(? nm)");
	UpdateData(FALSE);               
	return TRUE;
}
//__________________________________________________
void CBirefDlg::OnDemarrer() 
{
	KillTimer(0),
	AffecteV();
	VerifPara();
	AffecteZ();
	m_btnDemarrer.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnArreter.EnableWindow(TRUE); 
	GetDlgItem(IDC_SIGMA1)->EnableWindow(FALSE);
	GetDlgItem(IDC_SIGMA2)->EnableWindow(FALSE);
	GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
	GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(FALSE);
	GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(FALSE);
	m_iNb=0;
	m_pDoc->m_iNb=0;
	m_pDoc->m_OKRendement=FALSE;
	SetTimer(2,50,NULL);
}
//__________________________________________________
void CBirefDlg::OnArreter() 
{
	KillTimer(2);	
	GetDlgItem(IDC_SIGMA1)->EnableWindow(TRUE);
	GetDlgItem(IDC_SIGMA2)->EnableWindow(TRUE);
	GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
	GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(TRUE);
	GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(TRUE);
	m_btnDemarrer.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	m_btnArreter.EnableWindow(FALSE); 
	if (m_radioTypeScan==0)
		m_pDoc->m_iTypeGr=1;//Rfrence
	else
		m_pDoc->m_iTypeGr=2;//Echantillon
	m_pDoc->UpdateAllViews(NULL);
	SetTimer(0,200,NULL);
}
//__________________________________________________
void CBirefDlg::OnCancel() 
{
	KillTimer(0);
	delete m_pCandi;
	delete m_pEuro;
	//Libration console
	m_pApp->m_pChro->WriteCom("RL\r");
	if(m_pDoc->m_iNb!=0) m_pDoc->SetModifiedFlag(TRUE);
	UpdateData(TRUE);
	m_pDoc->m_fSigma1=m_fSigma1;
	m_pDoc->m_fSigma2=m_fSigma2;
	m_pDoc->m_fPasSigma=m_fPasSigma;
	m_pDoc->m_radioTypeScan=m_radioTypeScan;
	CDialog::OnCancel();
}
//________________________________________
void CBirefDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	BOOL ok;
	short 
		NbMax=20,
		nb,
		i,j,
		k,l;
	float u,lambda,sigma,
		r;

	j=(short)(pow(2,m_pApp->m_radioMoy));
	switch (nIDEvent)
	{
		case 0://Mise  jour bote de dialogue
			UpdateData(TRUE);
			GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(TRUE);
			GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(TRUE);
			if (m_radioTypeScan==0)
			{
				GetDlgItem(IDC_SIGMA1)->EnableWindow(TRUE);
				GetDlgItem(IDC_SIGMA2)->EnableWindow(TRUE);
				GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
			}
			else
			{
				//Echantillon
				GetDlgItem(IDC_SIGMA1)->EnableWindow(FALSE);
				GetDlgItem(IDC_SIGMA2)->EnableWindow(FALSE);
				GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
			}
			UpdateData(FALSE);
		break;
		//Paramtres du monochromateur: QM
		case 1://QM (4.36)
			m_iNb++;
			if (m_iNb>NbMax)
			{
				KillTimer(1);
				m_fL=m_pApp->m_pChro->QW();
				m_pDoc->m_iFE=m_iFE=m_pApp->m_pChro->QE();
				m_pDoc->m_iFS=m_iFS=m_pApp->m_pChro->QX();
				m_pApp->m_pChro->VideTampon();
				if (m_fL!=1e10 && m_iFE!=-1 && m_iFS!=-1)
				{
					m_s.Format("Lambda(nm): %1.2f\nFente d'entre (m): %d\nFente de sortie (m): %d",m_fL,m_iFE,m_iFS);
					m_pApp->m_pChro->VideTampon();
					m_btnArreter.EnableWindow(FALSE);
					m_btnDemarrer.EnableWindow(TRUE);
				}
				else
				{
					m_s.Format("Lambda (nm): ?\nFente d'entre (m): ?\nFente de sortie (m): ?");
				}
				SetTimer(0,200,NULL),
				m_btnCancel.EnableWindow(TRUE);
				UpdateData(FALSE);
			}
		break;
		case 2://Acquisition
			//Pour augmenter la vitesse de scan, on fait 5 acquisitions par timer...
			nb=0;
			do
			{
				nb++;
				sigma=m_fSigma2-m_iNb*m_fPasSigma;
				lambda=(float)(1E6/sigma);
				if (m_iNb>=m_iNbA || m_iNb>=m_pDoc->m_iNbMax-1)
				{
					KillTimer(2);
					m_btnDemarrer.EnableWindow(TRUE);
					m_btnCancel.EnableWindow(TRUE);
					m_btnArreter.EnableWindow(FALSE);
					GetDlgItem(IDC_SIGMA1)->EnableWindow(TRUE);
					GetDlgItem(IDC_SIGMA2)->EnableWindow(TRUE);
					GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
					GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(TRUE);
					GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(TRUE);
					if (m_radioTypeScan==0)
						m_pDoc->m_iTypeGr=1;//Rfrence
					else
						m_pDoc->m_iTypeGr=2;//Echantillon
					m_pDoc->UpdateAllViews(NULL);
					nb=5;
					SetTimer(0,200,NULL);
				}              
				else
				{
					//GW
					m_pApp->m_pChro->GW(lambda);
					//Lecture tension
					switch (m_pApp->m_iTypeCarte)
					{
						case 0://Eurosmart
							u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,j);
						break;
						case 1://Candibus
							u=m_pCandi->LitTension(m_pApp->m_radioVoie,j);
						break;
						default:
				  		u=-5+rand() % 11;
						break;
					}
					if (u!=1e10)
					{
						m_s.Format("Lambda(nm): %1.2f\nSigma(mm-1): %1.2f\nU[%d](V): %1.2f",lambda,sigma,j,u);
						//Ecriture tableau
						m_pDoc->m_fT[m_pDoc->m_iNb][0]=sigma;
				  	if (m_radioTypeScan==0)
				  	{
							//Rfrence
							m_pDoc->m_fT[m_pDoc->m_iNb][1]=u;
						}
						else
	  				{
							//Echantillon 
							m_pDoc->m_fT[m_pDoc->m_iNb][2]=u;
						}
						m_pDoc->m_iNb++;
					}
					else
					{	
						m_s.Format("Lambda(nm): %1.2f\nSigma(mm-1): %1.2f\nU[%d](V): ?",lambda,sigma,j);
					}
					//Indicateur de progression
					//Avancement en %
					i=(short)(100.0*(m_iNb+1)/m_iNbA);
					m_progress.SetPos(i);
					UpdateData(FALSE);
					m_iNb++;
				}
			}
			while(nb<5);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CBirefDlg::OnChangeSigma1() 
{
	int i;
	float r;
	UpdateData(TRUE);
	i=sscanf(m_sSigma1,"%f",&r);
	if (i==1)
	{ 
		m_fSigma1=r;
		r=1e6/r;
		if (r>100 && r<1100)
			m_sLambda1.Format("(%1.2f nm)",r);
		else
			m_sLambda1.Format("(? nm)");
	}
	else
	{
		m_fSigma1=620; 
		m_sLambda1="(? nm)";
	}
	UpdateData(FALSE);
}
//________________________________________
void CBirefDlg::OnChangeSigma2() 
{
	int i;
	float r;
	UpdateData(TRUE);
	i=sscanf(m_sSigma2,"%f",&r);
	if (i==1)
	{ 
		m_fSigma2=r;
		r=1e6/r;
		if (r>100 && r<1100)
			m_sLambda2.Format("(%1.2f nm)",r);
		else
			m_sLambda2.Format("(? nm)");
	}
	else
	{
		m_fSigma2=640; 
		m_sLambda2="(? nm)";
	}
	UpdateData(FALSE);
}
