// Bk.cpp : Defines the class behaviors for the application.
#include "stdafx.h"
#include "Bk.h"
#include "MainFrm.h"
#include "ChildFrm.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Chromex.h"
#include "ConRsDlg.h"
#include "EurosmartDX.h"
#include "CandibusDX.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CBkApp
BEGIN_MESSAGE_MAP(CBkApp, CWinApp)
	//{{AFX_MSG_MAP(CBkApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()
//________________________________________
class CChromex;
// CBkApp construction
CBkApp::CBkApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}
CBkApp::~CBkApp()
{
	for (short i=0;i<600;i++) pl[i].DeleteObject();
	delete []pl;
}
//________________________________________
// The one and only CBkApp object
CBkApp theApp;
//________________________________________
// CBkApp initialization
BOOL CBkApp::InitInstance()
{
	//Fentres______________________________
	SizeX=900;
	SizeY=(int)(1.0*SizeX*210/297);

	m_iNo=0;							//Fentre 0 par dfaut
	m_iNbFenMax=6;				//Nb. fentres maxi par dfaut
	m_iNbFen=0;
	m_pDocument=new CBkDoc*[m_iNbFenMax];
	m_OKF=new BOOL[m_iNbFenMax];
	short i;
	for (i=0;i<m_iNbFenMax;i++)
	{
		m_pDocument[i]=NULL;//Pointeur sur le document si ouvert
		m_OKF[i]=FALSE;			//Fentre pas ouverte
	}
	//Port srie____________________________
	m_radioPort=1;		//COM2
	m_OKConnect=FALSE;
	//Carte A/N_____________________________
	m_radioVoie=0;
	m_radioTypeAcq=1; //Bipolaire
	m_radioMoy=7;
	//Test carte connecte

	class CEurosmartDX* pEuro;
	pEuro=new CEurosmartDX();
	class CCandibusDX* pCand;
	pCand=new CCandibusDX();
	float u,u1;
	
	//On lit la tension sur les cartes
	u=pEuro->LitTension(0,0,2);
	u1=pCand->LitTension(0,2);

	if (u==1e10 && u1==1e10)
	{
		/*
		if (AfxMessageBox("AUCUNE carte A/N dtecte !\nSi une carte est prsente, installer sous une session ADMINISTRATEUR le logiciel :\nPort I/O Driver (port95nt.exe) ...\n\nDsirez-vous le tlcharger ?",MB_YESNO)==IDYES)
		{
			CString s="C:\\Program Files\\Internet Explorer\\IEXPLORE.EXE";
			CString s1="http://gop.mermoz.free.fr/visuim/port95nt.exe";
			HINSTANCE er;
			short er1;
			er=ShellExecute(NULL,"open",s,s1,"",SW_SHOWMAXIMIZED);
			er1=(short)er;
			if (er1<=32)
			AfxMessageBox("Le logiciel est disponible sous :\nhttp://gop.mermoz.free.fr/visuim"); 
		}
		*/
		AfxMessageBox("Aucune carte A/N dtecte !");
		m_iTypeCarte=-1;
	}
	else
	if (u!=1e10)
	{
		//Eurosmart
		AfxMessageBox("Carte Eurosmart dtecte.");
		m_iTypeCarte=0;
	}
	else
	{
		//Candibus
		AfxMessageBox("Carte Candibus dtecte.");
		m_iTypeCarte=1;
	}
	delete pCand;delete pEuro;
	//Monochromateur________________________
	m_pChro=NULL;
	m_radioTypMes=0; //Absortion____________
	m_iLambda1=600;
	m_iLambda2=400;
	m_iLambdaC1=600;
	m_iLambdaC2=400;
	//Paramtres Multi______________________
	m_sLambdaTab.RemoveAll();
	m_sLambdaTab.Add("580");
	m_sLambdaTab.Add("600");
	m_sLambdaTab.Add("620");


	//Plumes lambda: 600 plumes, 1 plume par nm entre 400 et 1000 nm 
	//p[0] -> 400 nm, p[599] -> 1000 nm
	pl=new CPen[600];
	unsigned char R,G,B;
	for (i=0;i<600;i++) 
	{
		CoulLambda(i+400,&R,&G,&B);//i+400 = longueur d'onde
		pl[i].CreatePen(PS_SOLID,45,RGB(R,G,B));
	}
	

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_BKTYPE,
		RUNTIME_CLASS(CBkDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CBkView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	return TRUE;
}

//________________________________________
//Couleurs d'aprs longueur d'onde
void CBkApp::CoulLambda(int lambda,unsigned char* rouge,unsigned char* vert,unsigned char* bleu)
{
	if (lambda>=630+127)
  {
		//IR lointain
		*rouge=127;
		*vert=127;
		*bleu=127;
  }
  else
	if (lambda>630 && lambda<630+127)
	{
		//IR
		*rouge=255-(lambda-630);
		*vert=lambda-630;
		*bleu=lambda-630;
	}	           
	else 
	{
		//Visible, UV
		float
			a,b;
			a=(float)(1023.0/(430-630)); //Rfrence: 640:Rouge, 430:Bleu
			b=-a*640;	
		
		lambda=(int)(a*lambda+b);
		if (lambda<0) lambda=0;
		int banque=lambda/256;//5 banques de 256 chantillons
		switch(banque)
		{
			case 0://0<=lambda<=255, R=255, V=0  255, B=0
				*rouge=255;
				*vert=lambda;
				*bleu=0;
			break;
			case 1://256<=lambda<=511, R=255  0, V=255, B=0
				*rouge=511-lambda;
				*vert=255;
				*bleu=0;
			break;
			case 2://512<=lambda<=767, R=0, V=255, B=0  255
				*rouge=0;
				*vert=255;
				*bleu=lambda-512;
			break;
			case 3://768<=lambda<=1023, R=0, V=255  0, B=255
				*rouge=0;
				*vert=1023-lambda;
				*bleu=255;
			break;
			case 4://1024<=lambda<=1279, R=0  255, V=0, B=255
				*rouge=lambda-1024;
				*vert=0;
				*bleu=255;
			break;
		}
	}
}
//________________________________________
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CListBox	m_liste;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Control(pDX, IDC_LISTE, m_liste);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CBkApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}
//________________________________________
// CBkApp commands
class CBkDoc *CBkApp::GetDocument(void)
{
	return m_pDocument[m_iNo];
}
//________________________________________
class CBkDoc *CBkApp::GetDocument(short No)
{
	return m_pDocument[No];
}
//________________________________________
int CBkApp::ExitInstance() 
{
	delete m_OKF;
	delete[] m_pDocument;
	return CWinApp::ExitInstance();
}
//________________________________________
BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	m_liste.AddString("05/04/09: Limite lambda 1100 nm");
	m_liste.AddString("20/07/07: Nouvel icne");
	m_liste.AddString("20/10/06: Retour vers DriverX");
	m_liste.AddString("28/09/06: Correction bogue CEurosmart");
	m_liste.AddString("27/09/06: Ajout carte Eurosmart PC-MES3");
	m_liste.AddString("25/09/06: Modification classe CCandibus");
	m_liste.AddString("18/09/06: Modification classe CConRsDlg");
	m_liste.AddString("15/08/06: Classe CCandibusDX");
	m_liste.AddString("04/10/04: Modification CPilotDlg");
	m_liste.AddString("07/02/04: Affichage quivalent lambda  ct de sigma");
	m_liste.AddString("27/03/03: Ajout chiffre significatif sur curseur");
	m_liste.AddString("07/03/03: Erreur intitul graphe FFT");
	m_liste.AddString("09/11/02: Extension nb. moyennage");
	m_liste.AddString("01/11/02: Acquisitions");
	m_liste.AddString("29/10/02: Graphes");
	m_liste.AddString("28/10/02: Pilotage et calibration");
	m_liste.AddString("06/10/02: Dbut criture programme");
	return TRUE;
}
