// BkView.cpp : implementation of the CBkView class
#include "stdafx.h"
#include "Bk.h"
#include "BkDoc.h"
#include "BkView.h"
#include "Dessin.h"
#include "SerieDlg.h"
#include "TestDlg.h"
#include "PilotDlg.h"
#include "SelGrDlg.h"
#include "SigGrDlg.h"
#include "TypAcDlg.h"
#include "LaAcqDlg.h"
#include "SiAcqDlg.h"
#include "RendDlg.h"
#include "AnDlg.h"
#include "DeFaDlg.h"
#include "BirefDlg.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//////////////////////////////////////////
// CBkView
IMPLEMENT_DYNCREATE(CBkView, CView)

BEGIN_MESSAGE_MAP(CBkView, CView)
	//{{AFX_MSG_MAP(CBkView)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_WM_DESTROY()
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_WM_CONTEXTMENU()
	ON_WM_SIZE()
	ON_WM_KEYDOWN()
	ON_UPDATE_COMMAND_UI(ID_ZOOM, OnUpdateZoom)
	ON_COMMAND(ID_ZOOM, OnZoom)
	ON_COMMAND(ID_ZOOM_TOUT, OnZoomTout)
	ON_COMMAND(ID_PORTSERIE, OnPortserie)
	ON_UPDATE_COMMAND_UI(ID_FIC_TXT, OnUpdateFicTxt)
	ON_COMMAND(ID_FIC_TXT, OnFicTxt)
	ON_UPDATE_COMMAND_UI(ID_TEST_SERIE, OnUpdateTestSerie)
	ON_COMMAND(ID_TEST_SERIE, OnTestSerie)
	ON_UPDATE_COMMAND_UI(ID_PILOTAGE, OnUpdatePilotage)
	ON_COMMAND(ID_PILOTAGE, OnPilotage)
	ON_UPDATE_COMMAND_UI(ID_GRAPHE_SELECTION, OnUpdateGrapheSelection)
	ON_COMMAND(ID_GRAPHE_SELECTION, OnGrapheSelection)
	ON_UPDATE_COMMAND_UI(ID_TYPE_ACQ, OnUpdateTypeAcq)
	ON_COMMAND(ID_TYPE_ACQ, OnTypeAcq)
	ON_UPDATE_COMMAND_UI(ID_ACQUERIR, OnUpdateAcquerir)
	ON_COMMAND(ID_ACQUERIR, OnAcquerir)
	ON_COMMAND(ID_RENDEMENT, OnRendement)
	ON_COMMAND(ID__CUR_SOURIS, InitSouris)
	ON_COMMAND(ID_CARTE_AN, OnCarteAn)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()
//////////////////////////////////////////
// CBkView construction/destruction
CBkView::CBkView()
{
	m_pApp=(CBkApp*)AfxGetApp();
	//Coord. souris_________________________
	m_iXd=0;m_iYd=0;
	m_iLig=-1;m_iCol=-1;
	//Zoom__________________________________
	InitZoom();
}
//________________________________________
CBkView::~CBkView()
{
}
//________________________________________
BOOL CBkView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}
//________________________________________
void CBkView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	if (bActivate) m_pApp->m_iNo=GetDocument()->m_iNo;
	CView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}
//////////////////////////////////////////
// CBkView drawing
void CBkView::OnDraw(CDC* pDC)
{
	class CBkDoc* pDoc=GetDocument();
	ASSERT_VALID(pDoc);
	//Pointeur sur document courant
	//m_pApp->m_iNo=pDoc->m_iNo;
	CString s;
	short i;
	float	
		xmi,ymi,xma,yma,
		ech;
		CRect rect;
	GetClientRect(rect);  
	pDC->DPtoLP(rect);            
	//Fentre graphique
	xmi=pDoc->m_fXmi;
	xma=pDoc->m_fXma;
	ymi=pDoc->m_fYmi;
	yma=pDoc->m_fYma;
	if (pDC->IsPrinting())
	{
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_TWIPS) ; 
		//Echelle pour sortie imprimante en fonction MM_TWIPS
		ech=1440.0/25.4;//1 twip = 1/1440e de pouce!
		//Dcalage axes
		pDC->SetWindowOrg(ech*xmi,ech*yma);
	}
	else
	{
		//1 mm est converti vers 100 pixels graphiques!
		ech=100.0;
		//Dtermination du systme de coordonnes     
		pDC->SetMapMode(MM_ISOTROPIC) ;
		//Dimensions de la fentre 
		pDC->SetWindowExt(ech*(xma-xmi),-ech*(yma-ymi));
		//Dcalage axes
		pDC->SetWindowOrg(ech*xmi,ech*yma);
		pDC->SetViewportExt(rect.right,rect.bottom);
	}
	class CDessin* pDes;
	pDes=new CDessin(pDC,pDoc,ech);
	if (pDoc->m_iNb!=0)
	{
		pDes->Zoom(m_fZoomXmi,m_fZoomYmi,m_fZoomXma,m_fZoomYma);
		//Moyenne sur carte A/N
		short j=(short)(pow(2,m_pApp->m_radioMoy));
		switch (pDoc->m_radioTypeAcq)
		{
 			case 0://U=f(Lambda)
				s.Format("ACQUISITION EN LAMBDA (E%d/X%d/M%d):",pDoc->m_iFE,pDoc->m_iFS,j);
				pDes->Titre=s;
				pDes->Absisse(0,0,"Lambda(nm)");
				pDes->Ordonnee(0,1,"U(V)");
				//pDes->Graphe5_1(1);//Couleur lambda
				pDes->Graphe5_1(0);//Couleur normale
 			break;
	 		case 1://Acquisition en sigma
				if (pDoc->m_iTypeGr & 16)
				{ 
					//FFT=f(Delta)                      
					s.Format("ACQUISITION EN SIGMA (E%d/X%d/M%d):",pDoc->m_iFE,pDoc->m_iFS,j);
					pDes->Titre=s;
					pDes->Absisse(0,3,"Delta(mm)");
					pDes->Ordonnee(0,4,"FFT");
					pDes->Graphe5_1(0);//Couleur normale
				}
				else
				{
					//U=f(Sigma)
					s.Format("ACQUISITION EN SIGMA (E%d/X%d/M%d):",pDoc->m_iFE,pDoc->m_iFS,j);
					pDes->Titre=s;
					pDes->Absisse(0,0,"Sigma(mm-1)");
					pDes->Ordonnee(0,1,"U(V)");
					//pDes->Graphe5_1(2);//Couleur sigma
					pDes->Graphe5_1(0);//Couleur normale
				}
			break;		  
	 		case 2://Densit optique/Facteur de transmission
				s.Format("ACQUISITION EN LAMBDA (E%d/X%d/M%d):",pDoc->m_iFE,pDoc->m_iFS,j);
				pDes->Titre=s;
				i=0;
				//Rfrence
				if (pDoc->m_iTypeGr & 1)
				{
					pDes->Absisse(i,0,"Lambda(nm)");
					pDes->Ordonnee(i,1,"U_Ref(V)");i++;
				}	
				//Echantillon
				if (pDoc->m_iTypeGr & 2)
				{
					pDes->Absisse(i,0,"Lambda(nm)");
					pDes->Ordonnee(i,2,"U_Ech(V)");i++;
				}	
				//Calculs
				if (pDoc->m_iTypeGr & 4)
				{
					if (pDoc->m_iTypeGr & 8)
					{
						//Fact. de transmission
						pDes->Absisse(i,0,"Lambda(nm)");
						pDes->Ordonnee(i,4,"Fact_trans");i++;
					}
					else
					{
						//Densit optique
						pDes->Absisse(i,0,"Lambda(nm)");
						pDes->Ordonnee(i,3,"Densit");i++;
					}
				}
				pDes->Graphe5_1(0);//Couleur normale
			break;
 			case 3://Birfringence/FFT
				s.Format("ACQUISITION EN SIGMA (E%d/X%d/M%d):",pDoc->m_iFE,pDoc->m_iFS,j);
				pDes->Titre=s;
				i=0;
				//Rfrence
				if (pDoc->m_iTypeGr & 1)
				{
					pDes->Absisse(i,0,"Sigma(mm-1)");
					pDes->Ordonnee(i,1,"U_Ref(V)");i++;
				}	
				//Echantillon
				if (pDoc->m_iTypeGr & 2)
				{
					pDes->Absisse(i,0,"Sigma(mm-1)");
					pDes->Ordonnee(i,2,"U_Ech(V)");i++;
				}
				if ((pDoc->m_iTypeGr&1) || (pDoc->m_iTypeGr&2))
				{
					//pDes->Graphe5_1(2);//Couleur sigma
					pDes->Graphe5_1(0);//Couleur normale
				}
				//Calculs
				if (pDoc->m_iTypeGr & 4)
				{
					if (pDoc->m_iTypeGr & 16)
					{
						//FFT
						pDes->Absisse(i,3,"Delta(mm)");
						pDes->Ordonnee(i,4,"Module FFT");i++;
						pDes->Graphe5_1(0);//Couleur normale
					}
					else
					{
						//Birfringence
						pDes->Absisse(i,0,"Sigma(mm-1)");
						pDes->Ordonnee(i,3,"Birfringence");i++;
						//pDes->Graphe5_1(2);//Couleur sigma
						pDes->Graphe5_1(0);//Couleur normale
					}
		    }
	 		break;
	 		case 4://Rendement de l'appareil
				pDes->Titre="RENDEMENT DE L'APPAREIL:";
				i=0;
				//Sensibilit
				if (pDoc->m_iTypeGr & 1)
				{
					pDes->Absisse(i,0,"Lambda(nm)");
					pDes->Ordonnee(i,1,"Sensibilit(A/W)");i++;
				}	
				//Efficacit
				if (pDoc->m_iTypeGr & 2)
				{
					pDes->Absisse(i,0,"Lambda(nm)");
					pDes->Ordonnee(i,2,"Efficacit");i++;
				}	
				//Rendement
				if (pDoc->m_iTypeGr & 4)
				{
					pDes->Absisse(i,0,"Lambda(nm)");
					pDes->Ordonnee(i,3,"Rendement");i++;
				}	
				pDes->Graphe5_1(0);//Couleur normale
 			break;
		}
		//Trac de la marque de pointage  la position de la souris
		if (pDoc->m_fDx!=0 && pDoc->m_fDy!=0)
		{                          
			if (m_OKAccro)
				pDes->MarqueDePointageVal(RGB(0,0,255),pDoc->m_fX,pDoc->m_fY);
			else
				pDes->MarqueDePointageVal(RGB(0,0,0),pDoc->m_fX,pDoc->m_fY);
		}
		m_iZoom=-1;
	}
	delete pDes;
}
//////////////////////////////////////////
// CBkView printing
BOOL CBkView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}
//__________________________________________________
void CBkView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}
//________________________________________
void CBkView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}
/////////////////////////////////////////////////////////////////////////////
// CBkView diagnostics
#ifdef _DEBUG
void CBkView::AssertValid() const
{
	CView::AssertValid();
}

void CBkView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CBkDoc* CBkView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CBkDoc)));
	return (CBkDoc*)m_pDocument;
}
#endif //_DEBUG
//////////////////////////////////////////
// CBkView message handlers
//________________________________________
void CBkView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();
	CBkDoc* pDoc=GetDocument();
	//On incrmente le nombre de fentres ouvertes
	m_pApp->m_iNbFen++;
	//Mmoriser le pointeur sur la fentre et la vue dans le document
	pDoc->m_pWnd=GetParent();
	pDoc->m_pView=this;
	//Taille de la fentre
	pDoc->DimensionnerFenetre(m_pApp->SizeX,m_pApp->SizeY);
}
//________________________________________
void CBkView::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	//On limite le nombre de fentres  m_iNbMax
	if (m_pApp->m_iNbFen>m_pApp->m_iNbFenMax-1)  pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	if (m_pApp->m_iNbFen>m_pApp->m_iNbFenMax-1)  pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnDestroy() 
{
	CView::OnDestroy();
	//On dcrmente le nombre de fentres ouvertes
	m_pApp->m_iNbFen--;
}
//________________________________________
void CBkView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	class CBkDoc* pDoc=GetDocument();
	float x,y,x1,y1;
	short n,i,j;
	CRect rectSave;
	class CRectTracker tracker;

	//pApp->m_iNo=pDoc->m_iNo;
	
	PIX_FEN(point.x,point.y,&x,&y);
	FEN_GR(x,y,&x,&y);

	//Zoom__________________________________
	if (m_iZoom==0)
	{
		//Fentre graphique
		m_tracker.GetTrueRect(rectSave);
		if (m_tracker.HitTest(point)<0)
		{
			if (tracker.TrackRubberBand(this,point,FALSE))
			{
				//MessageBeep(0);//Beep
				tracker.m_rect.NormalizeRect();
				//if (rect.IntersectRect(tracker.m_rect, m_tracker.m_rect))
				{
					if (m_tracker.m_nStyle & CRectTracker::resizeInside)
					{
						m_tracker.m_nStyle &= ~CRectTracker::resizeInside;
						m_tracker.m_nStyle |= CRectTracker::resizeOutside;
					}
					else
					{
						m_tracker.m_nStyle &= ~CRectTracker::resizeOutside;
						m_tracker.m_nStyle |= CRectTracker::resizeInside;
					}
					//pDoc->UpdateAllViews(NULL, (LPARAM)(LPCRECT)rectSave);
				}
			}
			//Mise  jour des coordonnes
			m_tracker.m_rect=tracker.m_rect;
		}
		else
		if (m_tracker.Track(this,point,FALSE))
		{
			//Quand on dplace la zone digitalise...
			//pDoc->UpdateAllViews(NULL,(LPARAM)(LPCRECT)rectSave);
		}
		//Coordonnes rectangle
		PIX_FEN(m_tracker.m_rect.left,m_tracker.m_rect.top,&x,&y);
		PIX_FEN(m_tracker.m_rect.right,m_tracker.m_rect.bottom,&x1,&y1);
		FEN_GR(x,y,&x,&y);
		FEN_GR(x1,y1,&x1,&y1);
		Zoom(x/pDoc->m_fFactx,y1/pDoc->m_fFacty,x1/pDoc->m_fFactx,y/pDoc->m_fFacty);
		pDoc->UpdateAllViews(NULL);
	}
	else
	{
		short ec=2;
		//Recherche si pointage souris peut tre accroch  un graphe...
		m_OKAccro=AccrocheGraphe(point,&ec,&n,&i,&j);
		if (m_OKAccro)
		{
			x=pDoc->m_fT[n][i];
			y=pDoc->m_fT[n][j];
			TAB_GR(x,y,&x,&y);			
			//Le pointeur est accroch aux mesures, mmorisation indices du tableau
			m_iCol=j;m_iLig=i;m_iNo=n;
		}
		pDoc->m_fDx=x;
		pDoc->m_fDy=y;
		pDoc->m_fX=x;
		pDoc->m_fY=y;
		//Mise  jour partielle de la vue en dessinant juste ce qui est ncessaire
		MajZone(m_iXd,m_iYd,point.x,point.y);
		m_iXd=(short)point.x;m_iYd=(short)point.y;
	}
	CView::OnLButtonDown(nFlags, point);
}
//________________________________________
void CBkView::OnMouseMove(UINT nFlags, CPoint point) 
{
	class CBkDoc* pDoc=GetDocument();
	float f_x,f_y;
	PIX_FEN(point.x,point.y,&f_x,&f_y);
	FEN_GR(f_x,f_y,&f_x,&f_y);
	pDoc->m_fX=f_x;
 	pDoc->m_fY=f_y;
	CView::OnMouseMove(nFlags, point);
}
//________________________________________
void CBkView::PIX_FEN(short xp,short yp,float *xmm,float *ymm) 
{
	//Changement de coordonnes Souris(pixels) -> Fentre
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;

	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xmm=pDoc->m_fXmi+xp/f_ech;
	*ymm=pDoc->m_fYma-yp/f_ech;
}
//________________________________________
void CBkView::FEN_GR(float xmm,float ymm,float *x,float *y) 
{
 	//Changement de coordonnes Fentre -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=(xmm/pDoc->m_fEchx+pDoc->m_fXori)*pDoc->m_fFactx;
	*y=(ymm/pDoc->m_fEchy+pDoc->m_fYori)*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_TAB(float x,float y,float *xt,float *yt) 
{
 	//Changement de coordonnes Graphe -> Tableau de mesures
	class CBkDoc *pDoc=GetDocument();
	*xt=x/pDoc->m_fFactx;
	*yt=y/pDoc->m_fFacty;
}
//________________________________________
void CBkView::TAB_GR(float xt,float yt,float *x,float *y) 
{
 	//Changement de coordonnes Tableau de mesures -> Graphe
	class CBkDoc *pDoc=GetDocument();
	*x=xt*pDoc->m_fFactx;
	*y=yt*pDoc->m_fFacty;
}
//________________________________________
void CBkView::GR_FEN(float x,float y,float *xmm,float *ymm) 
{
 	//Changement de coordonnes Graphe -> Fentre 
	class CBkDoc *pDoc=GetDocument();
	*xmm=(x/pDoc->m_fFactx-pDoc->m_fXori)*pDoc->m_fEchx;
	*ymm=(y/pDoc->m_fFacty-pDoc->m_fYori)*pDoc->m_fEchy;
}
//________________________________________
void CBkView::FEN_PIX(float xmm,float ymm,short *xp,short *yp) 
{
	//Changement de coordonnes Fentre -> Pixel (ex: Souris)
	class CBkDoc *pDoc=GetDocument();
	float 
		x,y,
		f_ech,f_echx,f_echy;
	CRect rect;

	GetClientRect(rect);
	f_echx=rect.right/(pDoc->m_fXma-pDoc->m_fXmi);
	f_echy=rect.bottom/(pDoc->m_fYma-pDoc->m_fYmi);
	//Calcul des coordonnes souris dans le repre du graphe
	if (f_echx<f_echy) 
		f_ech=f_echx; 
	else
		f_ech=f_echy;
	*xp=(xmm-pDoc->m_fXmi)*f_ech;
	*yp=(-ymm+pDoc->m_fYma)*f_ech;
}
//________________________________________
BOOL CBkView::AccrocheGraphe(CPoint point,short *ecart,short *no,short *li,short *co)
{
	short 
		n;
	CBkDoc* pDoc=GetDocument(); 
	BOOL OK;
	float 
		x,y,xt,yt,xf,yf;
	short
		xp,yp,
		ec,ecx,ecy,ecmini;

	OK=FALSE;
	ecmini=1000;
	*co=0;
	
	if (pDoc->m_radioTypeAcq==0)
	{
		//U=f(Lambda)
		*li=0;*co=1;
		n=0;
		while (n<pDoc->m_iNbMax && !OK)
		{
			xt=pDoc->m_fT[n][*li];
			yt=pDoc->m_fT[n][*co];
			if (xt!=1e10 && yt!=1e10)
			{
				TAB_GR(xt,yt,&x,&y); 
				GR_FEN(x,y,&xf,&yf); 
				FEN_PIX(xf,yf,&xp,&yp); 
				ecx=abs(xp-point.x);
				ecy=abs(yp-point.y);
				if (ecy>ecx) ec=ecy; else ec=ecx;
				if (ec<*ecart)
 				{
					OK=TRUE;      
				}
				if (ec<ecmini) 
				{
					ecmini=ec;
				}
			}
			n++;
		}
	}
	else
	if (pDoc->m_radioTypeAcq==1)
	{
		//SIGMA
		if (pDoc->m_iTypeGr & 16)
		{
			//FFT=f(Delta)                      
			*li=3;*co=4;
		}
		else
		{
			//U=f(Sigma)
			*li=0;*co=1;
		}
		n=0;
		while (n<pDoc->m_iNbMax && !OK)
		{
			xt=pDoc->m_fT[n][*li];
			yt=pDoc->m_fT[n][*co];
			if (xt!=1e10 && yt!=1e10)
			{
				TAB_GR(xt,yt,&x,&y); 
				GR_FEN(x,y,&xf,&yf); 
				FEN_PIX(xf,yf,&xp,&yp); 
				ecx=abs(xp-point.x);
				ecy=abs(yp-point.y);
				if (ecy>ecx) ec=ecy; else ec=ecx;
				if (ec<*ecart)
 				{
					OK=TRUE;      
				}
				if (ec<ecmini) 
				{
					ecmini=ec;
				}
			}
			n++;
		}
	}
	else
	//On cherche dans toutes les colonnes
	while((*co)<6 && !OK)
	{
		*li=0;
		while((*li)<6 && !OK)
		{
			n=0;
			while (n<pDoc->m_iNbMax && !OK)
			{
				xt=pDoc->m_fT[n][*li];
				yt=pDoc->m_fT[n][*co];
				if (xt!=1e10 && yt!=1e10)
				{
					TAB_GR(xt,yt,&x,&y); 
					GR_FEN(x,y,&xf,&yf); 
					FEN_PIX(xf,yf,&xp,&yp); 
					ecx=abs(xp-point.x);
					ecy=abs(yp-point.y);
					if (ecy>ecx) ec=ecy; else ec=ecx;
					if (ec<*ecart)
 					{
						OK=TRUE;      
					}
					if (ec<ecmini) 
					{
						ecmini=ec;
					}
				}
				n++;
			}
			if (!OK) *li=*li+1;
		}
		if (!OK) *co=*co+1;
	}

	*ecart=ecmini;
	if (OK)
	{
		*no=n-1;
	}
	else
	{
		*li=-1;
		*co=-1;
	}
	return OK;
}
//________________________________________
void CBkView::MajZone(short x1,short y1,short x2,short y2) 
{
	CRect rect1,rect2,rect3;
	short
		i=55,j=25;
	//Anciennes coordonnes
	rect1.left=x1-i;rect1.right=x1+i;rect1.top=y1-j;rect1.bottom=y1+j;
	//Nouvelles coordonnes
	rect2.left=x2-i;rect2.right=x2+i;rect2.top=y2-j;rect2.bottom=y2+j;
	rect3.UnionRect((LPCRECT)rect1,(LPCRECT)rect2);
	InvalidateRect(rect3,FALSE);
	GetDocument()->UpdateAllViews(this,(LPARAM)(LPCRECT)rect3);
}
//________________________________________
void CBkView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	CMenu menu;
	BOOL ok=menu.LoadMenu(IDR_POPUP);
	CMenu* pPopup=menu.GetSubMenu(0);
	if (pPopup!=NULL) pPopup->TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,NULL);
}
//________________________________________
void CBkView::InitSouris()
{
	//Initialisation coordonnnes souris
	//Voir: CBkView::OnContextMenu
	//Coordonnes relatives souris
	class CBkDoc *pDoc=GetDocument();
	pDoc->m_fDx=0;
	pDoc->m_fDy=0;
	pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CBkView::OnSize(UINT nType, int cx, int cy) 
{
	CView::OnSize(nType, cx, cy);
	class CBkDoc *pDoc=GetDocument();
	pDoc->m_fDx=0;
	pDoc->m_fDy=0;
	//AfxMessageBox("ici");
	m_pApp->m_iNo=pDoc->m_iNo;
}
//________________________________________
void CBkView::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	float x,y;
	short i,j,k;
	class CBkDoc* pDoc=GetDocument();
	CString s;
	//Appui touche
	if (m_iLig!=-1 &&	m_iCol!=-1)
	{
		if (nChar==37)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				m_iNo--;
				if (m_iNo<0) m_iNo=pDoc->m_iNb;
			}
			x=pDoc->m_fT[m_iNo][m_iLig];
			y=pDoc->m_fT[m_iNo][m_iCol];
			if (x!=1e10 && y!=1e10)
			{
				TAB_GR(x,y,&x,&y);
	 			pDoc->m_fDx=x;
				pDoc->m_fDy=y;
	 			pDoc->m_fX=x;
				pDoc->m_fY=y;
				GR_FEN(x,y,&x,&y);
				FEN_PIX(x,y,&i,&j);				
				if (m_OKAccro)	
				{
					MajZone(m_iXd,m_iYd,i,j);
					//Mmorisation anciennes coordonnes souris en mm et pixel		
					m_iXd=i;
					m_iYd=j;
				}
			}
		}
		if (nChar==39)
		{
			//Flche gauche
			for (k=0;k<nRepCnt;k++)
			{
				m_iNo++;
				if (m_iNo>pDoc->m_iNb) m_iNo=0;
			}
			x=pDoc->m_fT[m_iNo][m_iLig];
			y=pDoc->m_fT[m_iNo][m_iCol];
			if (x!=1e10 && y!=1e10)
			{
				TAB_GR(x,y,&x,&y);
	 			pDoc->m_fDx=x;
				pDoc->m_fDy=y;
	 			pDoc->m_fX=x;
				pDoc->m_fY=y;
				GR_FEN(x,y,&x,&y);
				FEN_PIX(x,y,&i,&j);				
				if (m_OKAccro)	
				{
					MajZone(m_iXd,m_iYd,i,j);
					//Mmorisation anciennes coordonnes souris en mm et pixel		
					m_iXd=i;
					m_iYd=j;
				}
			}
		}
	}
	CView::OnKeyDown(nChar, nRepCnt, nFlags);
}
//________________________________________
void CBkView::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
	m_iZoom=-1;
}
//________________________________________
void CBkView::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//________________________________________
void CBkView::InitTracker(void)
{                       
	m_tracker.m_rect.left=0;
	m_tracker.m_rect.top=0;
	m_tracker.m_rect.right=1;
	m_tracker.m_rect.bottom=1;
	//UpdateAllViews(NULL);
}
//________________________________________
void CBkView::TraceRectTracker(CDC *pDC)
{
	CPen 
		p,
		*m_pO;
	class CBkDoc* pDoc=GetDocument();
	p.CreatePen(PS_DOT,1,RGB(255,127,127));
	m_pO=pDC->SelectObject(&p);        
	pDC->MoveTo(m_tracker.m_rect.left,m_tracker.m_rect.top);
	pDC->LineTo(m_tracker.m_rect.right,m_tracker.m_rect.top);
	pDC->LineTo(m_tracker.m_rect.right,m_tracker.m_rect.bottom);
	pDC->LineTo(m_tracker.m_rect.left,m_tracker.m_rect.bottom);
	pDC->LineTo(m_tracker.m_rect.left,m_tracker.m_rect.top);
	m_tracker.Draw(pDC);
	pDC->SelectObject(m_pO);        
	p.DeleteObject();        
}
//________________________________________
void CBkView::OnUpdateZoom(CCmdUI* pCmdUI) 
{
	if (m_iZoom==0)
		//Zoom fenetre
		pCmdUI->SetCheck(1);
	else
		pCmdUI->SetCheck(0);
}
//________________________________________
void CBkView::OnZoom() 
{
	//Zoom fentre
	//(-1:Aucun, 0:Zoom F, 1:Zoom T)
	class CBkDoc* pDoc=GetDocument();
	m_pApp->m_iNo=pDoc->m_iNo;
	if (m_iZoom==-1)
	{ 
		pDoc->m_fDx=0;
		pDoc->m_fDy=0;
		//AfxMessageBox("Digitalisez une zone...");
		
	}
	m_iZoom=0;
}
//________________________________________
void CBkView::OnZoomTout() 
{
	class CBkDoc* pDoc=GetDocument();
	m_pApp->m_iNo=pDoc->m_iNo;
	InitZoom();
	pDoc->m_fDx=0;
	pDoc->m_fDy=0;
	pDoc->UpdateAllViews(NULL);
}
//________________________________________
void CBkView::OnUpdateFicTxt(CCmdUI* pCmdUI) 
{
	//On invalide la rubrique si m_iNb=0
	if (GetDocument()->m_iNb==0)	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnFicTxt() 
{
	//Sauver fichier compatible Excel
	CString s;
	short k;
	CBkDoc* pDoc=GetDocument();
	static char BASED_CODE szFilter[] = "Fichiers texte (*.txt) | *.txt |Tous les fichiers (*.*) | *.* ||";
	//CFileDialog dlg(FALSE,"",pDoc->m_sNomFicTxt,0,szFilter,NULL) ;
	CFileDialog dlg(FALSE,"","*.txt",0,szFilter,NULL) ;

	if (dlg.DoModal()==IDOK)
	{
		//Affectation nom du fichier
		//pDoc->m_sNomFicTxt=dlg.GetPathName();
		//Ouverture du fichier
		CFile fic;
		BOOL ok;
		unsigned int j=IDYES;     
		CFileException p_Error;
		//On regarde si le fichier existe dj
		ok=fic.Open(/*pDoc->m_sNomFicTxt*/dlg.GetPathName(),CFile::modeRead,&p_Error);
		if (ok)
		{
			j=AfxMessageBox("Ce fichier existe dj. Voulez-vous le remplacer ?",MB_YESNO);
		} 
		if (j==IDYES)
		{
			if (ok) fic.Close();
			//Ouverture du fichier en mode CREATE			
			ok=fic.Open(dlg.GetPathName(),CFile::modeWrite|CFile::modeCreate,&p_Error);
			if (!ok)
			{
				AfxMessageBox("Erreur d'ouverture du fichier en mode cration !");
			}
			else
			{
				switch (pDoc->m_radioTypeAcq)
				{
 					case 0://U=f(Lambda)
						//Ecriture des donnes dans le fichier
						s.Format("Monochromateur - Acquisition en lambda\r\n");
						fic.Write(s,s.GetLength());
						s.Format("%6s\t%6s\r\n","Lambda(nm)","U(V)");
						fic.Write(s,s.GetLength());
						for (k=0;k<pDoc->m_iNb;k++)
						{          
							s.Format("%6.2f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1]);
							fic.Write(s,s.GetLength());
						}
 					break;
					case 1://U=f(Sigma)
						//Ecriture des donnes dans le fichier
						s.Format("Monochromateur - Acquisition en sigma\r\n");
						fic.Write(s,s.GetLength());
						s.Format("%6s\t%6s\r\n","Sigma(mm-1)","U(V)");
						fic.Write(s,s.GetLength());
						for (k=0;k<pDoc->m_iNb;k++)
						{          
							s.Format("%6.2f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1]);
							fic.Write(s,s.GetLength());
						}
 					break;    
 					case 2://Densit optique/Fact. de transmission
						if (pDoc->m_iTypeGr & 4)
						{
							//Calculs
							if (pDoc->m_iTypeGr & 8)
							{
								//Lambda, U_Ref, U_Echan, Fact. de transmission
								s.Format("Monochromateur - Facteur de transmission\r\n");
								fic.Write(s,s.GetLength());
								s.Format("%6s\t%6s\t%6s\t%6s\r\n","Lambda(nm)","U_Ref(V)","U_Ech(V)","Fact. trans.");
								fic.Write(s,s.GetLength());
								for (k=0;k<pDoc->m_iNb;k++)
								{          
									if (pDoc->m_fT[k][4]!=1e10)
									{
										s.Format("%6.2f\t%6.3f\t%6.3f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1],pDoc->m_fT[k][2],pDoc->m_fT[k][4]);
										fic.Write(s,s.GetLength());
									}	
								}
							}
							else
							{
								//Lambda, U_Ref, U_Echan, Densit
								s.Format("Monochromateur - Densit\r\n");
								fic.Write(s,s.GetLength());
								s.Format("%6s\t%6s\t%6s\t%6s\r\n","Lambda(nm)","U_Ref(V)","U_Ech(V)","Densit");
								fic.Write(s,s.GetLength());
								for (k=0;k<pDoc->m_iNb;k++)
								{          
									if (pDoc->m_fT[k][3]!=1e10)
									{
										s.Format("%6.2f\t%6.3f\t%6.3f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1],pDoc->m_fT[k][2],pDoc->m_fT[k][3]);
										fic.Write(s,s.GetLength());
									}	
								}
							}	
 					  }
 					  else
 					  {
 					  	//Lambda, U_Ref, U_Echan
							s.Format("Monochromateur - Densit - Acq. ref. et chant.\r\n");
							fic.Write(s,s.GetLength());
							s.Format("%6s\t%6s\t%6s\r\n","Lambda(nm)","U_Ref(V)","U_Ech(V)");
							fic.Write(s,s.GetLength());
							for (k=0;k<pDoc->m_iNb;k++)
							{          
								s.Format("%6.2f\t%6.3f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1],pDoc->m_fT[k][2]);
								fic.Write(s,s.GetLength());
							}
 					  }
 					break;
 					case 3://Birfringence/FFT
						if (pDoc->m_iTypeGr & 4)
						{
							//Calculs
							if (pDoc->m_iTypeGr & 16)
							{
								//FFT
								s.Format("Monochromateur - Diffrence de marche\r\n");
								fic.Write(s,s.GetLength());
								s.Format("%6s\t%6s\r\n","Delta(mm)","FFT");
								fic.Write(s,s.GetLength());
								for (k=0;k<pDoc->m_iNb;k++)
								{          
									if (pDoc->m_fT[k][4]!=1e10)
									{
										s.Format("%6.3f\t%6.3f\r\n",pDoc->m_fT[k][3],pDoc->m_fT[k][4]);
										fic.Write(s,s.GetLength());
									}	
								}
							}
							else
							{
								//Sigma, U_Ref, U_Echan, Birfringence
								s.Format("Monochromateur - Birfrigence\r\n");
								fic.Write(s,s.GetLength());
								s.Format("%6s\t%6s\t%6s\t%6s\r\n","Sigma(mm-1)","U_Ref(V)","U_Ech(V)","Biref.");
								fic.Write(s,s.GetLength());
								for (k=0;k<pDoc->m_iNb;k++)
								{          
									if (pDoc->m_fT[k][3]!=1e10)
									{
										s.Format("%6.2f\t%6.3f\t%6.3f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1],pDoc->m_fT[k][2],pDoc->m_fT[k][3]);
										fic.Write(s,s.GetLength());
									}	
								}
							}	
 					  }
 					  else
 					  {
 					  	//Lambda, U_Ref, U_Echan
							s.Format("Monochromateur - Birfringence - Acq. ref. et chant.\r\n");
							fic.Write(s,s.GetLength());
							s.Format("%6s\t%6s\t%6s\r\n","Sigma(mm-1)","U_Ref(V)","U_Ech(V)");
							fic.Write(s,s.GetLength());
							for (k=0;k<pDoc->m_iNb;k++)
							{          
								s.Format("%6.2f\t%6.3f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1],pDoc->m_fT[k][2]);
								fic.Write(s,s.GetLength());
							}
 					  }
 					break;
 					case 4://Rendement
						s.Format("Monochromateur - Rendement appareil\r\n");
						fic.Write(s,s.GetLength());
						s.Format("%6s\t%6s\t%6s\t%6s\r\n","Lambda(nm)","Sensibilit(A/W)","Efficacit rseau","Rendement");
						fic.Write(s,s.GetLength());
						for (k=0;k<pDoc->m_iNb;k++)
						{          
							s.Format("%6.3f\t%6.3f\t%6.3f\t%6.3f\r\n",pDoc->m_fT[k][0],pDoc->m_fT[k][1],pDoc->m_fT[k][2],pDoc->m_fT[k][3]);
							fic.Write(s,s.GetLength());
						}
 					break;
 				}	
				fic.Close();
			}
		}
	}	
}
//________________________________________
void CBkView::OnPortserie() 
{
	m_pApp->m_iNo=GetDocument()->m_iNo;
	CSerieDlg d;
	d.DoModal();
}
//________________________________________
void CBkView::OnUpdateTestSerie(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_OKConnect) pCmdUI->Enable(FALSE); 	
}
//________________________________________
void CBkView::OnTestSerie() 
{
	CTestDlg d;
	d.DoModal();	
}
//________________________________________
void CBkView::OnUpdatePilotage(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_OKConnect) pCmdUI->Enable(FALSE); 	
}
//________________________________________
void CBkView::OnPilotage() 
{
	CPilotDlg d;
	d.DoModal();	
}
//________________________________________
void CBkView::OnUpdateGrapheSelection(CCmdUI* pCmdUI) 
{
	//Slection du graphe  visualiser
	if (GetDocument()->m_radioTypeAcq==4 || GetDocument()->m_iNb==0) 	pCmdUI->Enable(FALSE);
}
//________________________________________
void CBkView::OnGrapheSelection() 
{
	//Slection du graphe  visualiser
	CSelGrDlg d;
	CSigGrDlg d1;
	if (GetDocument()->m_radioTypeAcq==1)
	{
		//Sigma
		d1.DoModal();		
	}
	else
	{
		//Autres
		d.DoModal();		
	}
}
//________________________________________
void CBkView::OnUpdateTypeAcq(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_OKConnect) pCmdUI->Enable(FALSE); 	
}
//________________________________________
void CBkView::OnTypeAcq() 
{
	CTypAcDlg d;
	d.DoModal();	
}
//________________________________________
void CBkView::OnUpdateAcquerir(CCmdUI* pCmdUI) 
{
	if (!m_pApp->m_OKConnect) pCmdUI->Enable(FALSE); 	
}
//________________________________________
void CBkView::OnAcquerir() 
{
	//Acquisition d'un spectre
	CBkDoc* pDoc=GetDocument();
	CLaAcqDlg d;
	CSiAcqDlg d1;
	CDeFaDlg d2;
	CBirefDlg d3;
	switch (pDoc->m_radioTypeAcq)
	{
		case 0://Lambda=f(U)	
			d.DoModal();		  
		break;	
		case 1://Sigma=f(U)	
			d1.DoModal();		  
		break;	
		case 2://Densit optique/Facteur de transmission	
			d2.DoModal();		  
		break;	
		case 3://Birfringence/FFT
			d3.DoModal();		  
		break;	
	}
}
//________________________________________
void CBkView::OnRendement() 
{
	CRendDlg d;
	d.DoModal();	
}
//________________________________________
void CBkView::OnCarteAn() 
{
	CAnDlg d;
	d.DoModal();	
}
