// Dessin.cpp : implementation file
#include "stdafx.h"
#include "bk.h"
#include "Dessin.h"
#include "BkDoc.h"
#include <math.h>
#include <sys/timeb.h>
#include <locale.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
CDessin::CDessin(class CDC* pDC,class CBkDoc* pDoc,float f_ech)
{                       
	m_pApp=(CBkApp*)AfxGetApp();
	m_ech=f_ech;
	m_pDC=pDC;
	m_pDoc=pDoc;

	m_fHautTexte=4.5;//Hauteur rfrence du texte en mm
	echx=1;
	echy=1;
	xori=0;
	yori=0;
	factx=1;
	facty=1;
	xmi=m_pDoc->m_fXmi;
	ymi=m_pDoc->m_fYmi;
	xma=m_pDoc->m_fXma;
	yma=m_pDoc->m_fYma;  
	//Pour trac graphes...
	if (m_pDoc->m_iNb>0)
	{
		Nb=m_pDoc->m_iNb;
		fT=m_pDoc->m_fT;
		//Initialisation des graphes  tracer et des noms abs/ord
		for (short i=0;i<5;i++)
		{
			for (short j=0;j<2;j++)
			{
				iD_Axes[j][i]=-1;
				iN_Axes[j][i]="";
			}
		}
	}
	//Pas de zoom par dfaut
	InitZoom();
}
//________________________________________
CDessin::~CDessin()
{
	//Mise  jour des paramtres de trac
	if (m_pDoc->m_iNb>0)
	{
		m_pDoc->m_fXmi=xmi;	
		m_pDoc->m_fYmi=ymi;	
		m_pDoc->m_fXma=xma;	
		m_pDoc->m_fYma=yma;	
		//Mise  jour des chelles pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fEchx=echx;	
		m_pDoc->m_fEchy=echy;	
		//Mise  jour du dcalage d'origine pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fXori=xori;	
		m_pDoc->m_fYori=yori;	
		//Mise  jour du fact. puissance de 10 pour affichage coordonnes  l'aide de la souris
		m_pDoc->m_fFactx=factx;	
		m_pDoc->m_fFacty=facty;	 
	}
}
//________________________________________
void CDessin::MoveTo(float x,float y)
{
	m_pDC->MoveTo((int)(x*m_ech),(int)(y*m_ech));
}
//________________________________________
void CDessin::LineTo(float x,float y)
{
	m_pDC->LineTo((int)(x*m_ech),(int)(y*m_ech));
}
//________________________________________
void CDessin::Line(float xd,float yd,float xa,float ya)
{
	m_pDC->MoveTo((int)(xd*m_ech),(int)(yd*m_ech));
	m_pDC->LineTo((int)(xa*m_ech),(int)(ya*m_ech));
}
//________________________________________
void CDessin::Arc(float xg,float yb,float xd,float yh,float x1, float y1,float x2,float y2)
{
	m_pDC->Arc((int)(xg*m_ech),(int)(yb*m_ech),(int)(xd*m_ech),(int)(yh*m_ech),(int)(x1*m_ech),(int)(y1*m_ech),(int)(x2*m_ech),(int)(y2*m_ech));
}
//________________________________________
void CDessin::Arc(float xc,float yc,float ray,float xd,float yd,float xa,float ya)
{
  short
  	x1,x2,x3,x4,y1,y2,y3,y4;
  x1=(int)((xc-ray)*m_ech);	
  y1=(int)((yc+ray)*m_ech);	
  x2=(int)((xc+ray)*m_ech);	
  y2=(int)((yc-ray)*m_ech);	
  x3=(int)(xd*m_ech);	
  y3=(int)(yd*m_ech);	
  x4=(int)(xa*m_ech);	
  y4=(int)(ya*m_ech);	
	m_pDC->Arc(x1,y1,x2,y2,x3,y3,x4,y4);
}
//________________________________________
void CDessin::Circle(float xc,float yc,float ray)
{
  short
  	x1,x2,x3,x4,y1,y2,y3,y4;
  x1=(int)((xc-ray)*m_ech);	
  y1=(int)((yc+ray)*m_ech);	
  x2=(int)((xc+ray)*m_ech);	
  y2=(int)((yc-ray)*m_ech);	
  x3=(int)((xc-ray)*m_ech);	
  y3=(int)((yc)*m_ech);	
  x4=(int)((xc-ray)*m_ech);	
  y4=(int)((yc)*m_ech);	
	m_pDC->Arc(x1,y1,x2,y2,x3,y3,x4,y4);
}
//________________________________________
void CDessin::TextOut(float x,float y,CString s)
{
	m_pDC->TextOut((int)(x*m_ech),(int)(y*m_ech),s);     
}
//________________________________________
void CDessin::Rectangle(float xg,float yb,float xd,float yh)
{
	m_pDC->Rectangle((int)(xg*m_ech),(int)(yh*m_ech),(int)(xd*m_ech),(int)(yb*m_ech));
}   
//________________________________________
void CDessin::Fleche(float xp,float yp,float a,float l)
{
  const 
  	float PI=(float)(4*atan(1)),
  	ang=(float)(15.0*PI/180);
  a=a+PI;
	m_pDC->MoveTo((int)((xp+l*cos(a+ang))*m_ech),(int)((yp+l*sin(a+ang))*m_ech));
	m_pDC->LineTo((int)(xp*m_ech),(int)(yp*m_ech));
	m_pDC->LineTo((int)((xp+l*cos(a-ang))*m_ech),(int)((yp+l*sin(a-ang))*m_ech));
}
//________________________________________
short CDessin::Graphe5_1(short type)
{    
  CPen 
  	plumeC,       
  	plumeD,
  	plumeX,
  	plumeY,
  	plumeM,
  	plumeR,
  	plumeI,
  	plumeJ,
  	*m_pOldPen;
	CFont 
		fntC,  
		fntD,
		*m_pOldFont;
	COLORREF clrOld;	
	const float PI=(float)(4*atan(1));
  short
  	i,j,k,l,
		nb[5]={0,0,0,0,0}; 
  float
  	r,
  	x,y,xd,yd,xa,ya,
		xmin=1e10,ymin=1e10,xmax=-1e10,ymax=-1e10,
		larg,haut,  //Dimensions de la fenetre
		pasx,pasy;	
	long
		cc[5]={RGB(255,0,0),RGB(0,128,0),RGB(0,0,128),RGB(221,86,13),RGB(255,0,255)};	
	CString	s;	             
	BOOL ok;		


	for(i=0;i<Nb;i++)
	{                    
		for (j=0;j<5;j++)
		{
			//Absisses
			if (iD_Axes[0][j]!=-1 && iD_Axes[1][j]!=-1) 
			{
				//Ce couple abs/ord est  tracer
				if (fT[i][iD_Axes[0][j]]>m_fZoomXmi && fT[i][iD_Axes[0][j]]<m_fZoomXma && fT[i][iD_Axes[1][j]]>m_fZoomYmi && fT[i][iD_Axes[1][j]]<m_fZoomYma) 
				{
					if (fT[i][iD_Axes[0][j]]<xmin) xmin=fT[i][iD_Axes[0][j]];
					if (fT[i][iD_Axes[0][j]]>xmax) xmax=fT[i][iD_Axes[0][j]];
					if (fT[i][iD_Axes[1][j]]<ymin) ymin=fT[i][iD_Axes[1][j]];
					if (fT[i][iD_Axes[1][j]]>ymax) ymax=fT[i][iD_Axes[1][j]];
					nb[j]++;
				}
			}
		}
	}
	ok=FALSE;
	for (k=0;k<5;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1 && nb[k]>=2) ok=TRUE;
	}
	if (!ok) return 1;
  
	//s.Format("xmin:%f, xmax:%f",xmin,ymin);AfxMessageBox(s);

	//Calcul des chelles, prvoir ventuellement une marge...
	larg=xma-xmi;
	haut=yma-ymi;
  //Si les valeurs sont constantes
	if (fabs(ymax-ymin)<1e-8)
	{
		ymax=(float)(ymax+0.01);
		ymin=(float)(ymin-0.01);
	}
	if (fabs(xmax-xmin)<1e-8)
	{
		xmax=(float)(xmax+0.01);
		xmin=(float)(xmin-0.01);
	}                                
	echx=(larg-70)/(xmax-xmin);                    
	echy=(haut-70)/(ymax-ymin);
	//Calcul pasx
	pasx=1e-10;
	do
	{
		pasx=pasx*10;
	}                              
	while	(echx*pasx<=1);
	pasx=pasx*5;
	//Calcul pasy
	pasy=1e-10;
	do
	{
		pasy=pasy*10;
	}           
	while	(echy*pasy<=1);		
	pasy=pasy*10;
	//Rajustement en fonction du nombre de divisions de l'axe
	i=(int)((xmax-xmin)/pasx);
	if (i<=2) pasx=pasx/4;
	else
	if (i<=5) pasx=pasx/2;
	if (i>12) pasx=pasx*2;

	j=(int)((ymax-ymin)/pasy);
	if (j<=2) pasy=pasy/4;
	else
	if (j<=5) pasy=pasy/2;
	//Recherche facteurs axes x et y
	if (fabs(xmin)>fabs(xmax))
		x=xmin;
	else
		x=xmax;
	if (x!=0)
	{
		factx=1e-10;
		do
		{
			factx=factx*10;
		}
		while (fabs(x*factx)<1);	
	}	                           
	else
		factx=1;

	if (fabs(ymin)>fabs(ymax))
		y=ymin;
	else
		y=ymax;

	if (y!=0)
	{
		facty=1e-10;
		do
		{
			facty=facty*10;
		}
		while (fabs(y*facty)<1);	
	}	                           
	else
		facty=1;
	//Calcul xori et yori
	xori=0;yori=0;
	if ((xmin<=0) && (xmax>=0))
		xori=0;
	else
	{
		//xori=xmin;	
		if (xmin>0)
		{
			//On encadre dans le sens positif
			xori=0;
			do
			{
				xori=xori+pasx;
			}
			while (xori<xmin);
			xori=xori-pasx;
		}
		else
		{
			//On encadre dans le sens ngatif
			xori=0;
			do
			{
				xori=xori-pasx;
			}
			while (xori>xmin);
			xori=xori+pasx;
		}
	}	
	if ((ymin<=0) && (ymax>=0))
		yori=0;
	else
	{
		if (ymin>0)
		{
			//On encadre dans le sens positif
			yori=0;
			do
			{
				yori=yori+pasy;
			}
			while (yori<ymin);
			yori=yori-pasy;
		}
		else
		{
			//On encadre dans le sens ngatif
			yori=0;
			do
			{
				yori=yori-pasy;
			}
			while (yori>ymin);
			yori=yori+pasy;
		}

  }
	//Dplacement de l'origine de la fenetre graphique    
	if (xori!=0)
		xmi=-30;//-40, Modifi le 30/10/02		
	else
		xmi=xmin*echx-40;		
	xma=xmi+larg;		
	if (yori!=0)
		ymi=-30;		
	else
		ymi=ymin*echy-30;		
	yma=ymi+haut;
  //Dcalage axes
  m_pDC->SetWindowOrg((int)(m_ech*xmi),(int)(m_ech*yma));

	fntC.CreateFont((int)(m_ech*m_fHautTexte*0.8),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntC);	  
	m_pDC->SetTextAlign(TA_LEFT);							
	clrOld=m_pDC->SetTextColor(RGB(0,0,255));
  plumeC.CreatePen(PS_SOLID,(int)(0.20*m_ech),RGB(0,0,0));
	m_pOldPen=m_pDC->SelectObject(&plumeC);        
  Rectangle(xmi,ymi,xma,yma);
	//Dtermination zone de trac
	xa=pasx;
	while(xa*echx<=(xma-5))
	{
		xa=xa+pasx;
	}
	xa=xa-pasx;
	xa=xa*echx;
	
	xd=-pasx;
	while(xd*echx>=(xmi+5))
	{
		xd=xd-pasx;
	}
	xd=xd+pasx;
	xd=xd*echx;
  ya=pasy;
  while (ya*echy<=(yma-5))
  {                        
  	ya=ya+pasy;
  }     
  ya=ya-pasy;                  
  ya=ya*echy;
  yd=-pasy;
  while (yd*echy>=(ymi+5))
  {                        
  	yd=yd-pasy;
  } 
  yd=yd+pasy;
  yd=yd*echy;
  //Cadre autour de la zone 
  Rectangle(xd,yd,xa,ya);

  TextOut((float)(xmi+0.5),(float)(ymi+4.5),"B.K. - Lyce J. Mermoz - 68300 ST.-LOUIS");
	//Date et heure
	CTime t;
	setlocale(LC_TIME,"French");
	t=CTime::GetCurrentTime();   
	s=t.Format("%A, %d %B %Y - %H:%M:%S");
	m_pDC->SetTextAlign(TA_RIGHT);							
	TextOut((float)(xma-1.0),(float)(ymi+4.5),s);
	//Trac des axes  
	Line(xd,0,xa,0);
	Line(0,yd,0,ya);
  plumeD.CreatePen(PS_SOLID,(int)(0*m_ech),RGB(127,127,127));
	m_pDC->SelectObject(&plumeD);        
	fntD.CreateFont((int)(m_ech*m_fHautTexte),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER);							
	m_pDC->SetTextColor(RGB(0,0,0));
  //Division axe x
  x=pasx;
  while (x*echx<=(xma-5))
  {           
  	r=x*echx;
  	s.Format("%1.3f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x+pasx;
  }                   
  x=-pasx;
  while (x*echx>=(xmi+5))
  {           
  	r=x*echx;
  	s.Format("%1.2f",(x+xori)*factx);
  	TextOut(r,-2.5,s);  
  	Line(r,yd,r,-7.00);
  	Line(r,0.0,r,ya);
    x=x-pasx;
  }                      
	//Division axe y
	m_pDC->SetTextAlign(TA_RIGHT);							
	y=0;
	while(y*echy<=(yma-5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y+pasy;
	}		  
	y=-pasy;
	while(y*echy>=(ymi+5))
	{          
  	r=y*echy;
  	s.Format("%1.2f",(y+yori)*facty);
  	TextOut(-2.00,(float)(r+2.0),s);  
  	if (xd<-15) Line(xd,r,-10,r);
  	Line(0.0,r,xa,r);
		y=y-pasy;
	}		                  
	//Ecriture des chelles
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_BASELINE);							
	s.Format("Echx:%7.2e / Echy:%7.2e",echx,echy);
	TextOut((float)(xd+1.50),(float)(yma-5.00),s);  
	//Ecriture facteurs axes x et noms axes abscisses
	//Toujours fonteD
	m_pDC->SetTextAlign(TA_RIGHT | TA_BOTTOM);							
	r=1.0;          
	for (k=0;k<5;k++)
	{
		if (iD_Axes[0][k]!=-1)
		{
			if (type==0)
				m_pDC->SetTextColor(cc[k]);
			else
				m_pDC->SetTextColor(RGB(255,0,0));
			s.Format("%s*%5.0e",iN_Axes[0][k],1/factx);
			TextOut(xa-1.0,r,s);
			r=r+5.0;
		}
	}
	//Ecriture du titre
	r=ya-5.0;
	m_pDC->SelectObject(&fntD);	  
	//m_pDC->SetTextAlign(TA_CENTER);							
	//TextOut((float)((xmi+xma)/2),(float)(yma-30.0),Titre);  
	m_pDC->SetTextColor(RGB(0,0,0));
	m_pDC->SetTextAlign(TA_BASELINE);							
	TextOut(3.0,r,Titre);  
	//Ecriture facteurs axes y et noms axes ordonnes
	r=r-5.0;
	m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_BASELINE);							
	for (k=0;k<5;k++)
	{
		if (iD_Axes[1][k]!=-1)
		{
			if (type==0)
				m_pDC->SetTextColor(cc[k]);
			else
				m_pDC->SetTextColor(RGB(255,0,0));

			s.Format("%s*%5.0e",iN_Axes[1][k],1/facty);
			TextOut(3.0,r,s);
			r=r-5.0;
		}
	}
	//Trac graphe                    
  plumeX.CreatePen(PS_SOLID,(int)(0.45*m_ech),cc[0]);
  plumeY.CreatePen(PS_SOLID,(int)(0.45*m_ech),cc[1]);
  plumeM.CreatePen(PS_SOLID,(int)(0.45*m_ech),cc[2]);
  plumeR.CreatePen(PS_SOLID,(int)(0.45*m_ech),cc[3]);
  plumeI.CreatePen(PS_SOLID,(int)(0.45*m_ech),cc[4]);
  plumeJ.CreatePen(PS_SOLID,(int)(0.45*m_ech),cc[5]);

	for (k=0;k<5;k++)
	{
		if (iD_Axes[0][k]!=-1 && iD_Axes[1][k]!=-1)
		{
			for (i=1;i<Nb;i++)
			{
				xd=fT[i-1][iD_Axes[0][k]];
				yd=fT[i-1][iD_Axes[1][k]];
				xa=fT[i][iD_Axes[0][k]];
				ya=fT[i][iD_Axes[1][k]];
				if (xd>m_fZoomXmi && yd>m_fZoomYmi && xa<m_fZoomXma && ya<m_fZoomYma)
				{
					//Choix de la plume
					switch (type)
					{
						case 0://Plumes normales	
							switch (k)
							{
								case 0:
									m_pDC->SelectObject(&plumeX);        
								break;
								case 1:
									m_pDC->SelectObject(&plumeY);        
								break;
								case 2:
									m_pDC->SelectObject(&plumeM);        
								break;
								case 3:
									m_pDC->SelectObject(&plumeR);        
								break;
								case 4:
									m_pDC->SelectObject(&plumeI);        
								break;
								case 5:
									m_pDC->SelectObject(&plumeJ);        
								break;
							}
							xd=(xd-xori)*echx;
							yd=(yd-yori)*echy;
							xa=(xa-xori)*echx;
							ya=(ya-yori)*echy;
							if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
								Line(xd,yd,xa,ya);
						break;
						case 1://Slection de plumes de couleur lambda	
							l=(short)(xa);
							if (l<400) l=999;
							if (l>999) l=999;
							m_pDC->SelectObject(&(m_pApp->pl[l-400]));
							xd=(xd-xori)*echx;
							yd=(yd-yori)*echy;
							xa=(xa-xori)*echx;
							ya=(ya-yori)*echy;
							if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
								Line(xd,yd,xa,ya);
						break;
						case 2://Slection de plumes de couleur 1/lambda ou sigma	
							r=(float)(1E6/xa); 
							l=(short)(r);
							if (l<400) l=999;
							if (l>999) l=999;
							xd=(xd-xori)*echx;
							yd=(yd-yori)*echy;
							xa=(xa-xori)*echx;
							ya=(ya-yori)*echy;
							m_pDC->SelectObject(&(m_pApp->pl[l-400]));
							if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
								Line(xd,yd,xa,ya);
						break;
						default://Slection de plume de couleur type
							l=(short)(type);
							if (l<400) l=999;
							if (l>999) l=999;
							xd=(xd-xori)*echx;
							yd=(yd-yori)*echy;
							xa=(xa-xori)*echx;
							ya=(ya-yori)*echy;
							m_pDC->SelectObject(&(m_pApp->pl[l-400]));
							if ((xd>xmi+5)&&(xd<xma-5)&&(yd>ymi+5)&&(yd<yma-5)&&(xa>xmi+5)&&(xa<xma-5)&&(ya>ymi+5)&&(ya<yma-5))
								Line(xd,yd,xa,ya);
						break;
					}
				}
			}
		}
	}
	m_pDC->SelectObject(m_pOldPen);        
	plumeX.DeleteObject();        
	plumeY.DeleteObject();        
	plumeM.DeleteObject();        
	plumeR.DeleteObject();        
	plumeI.DeleteObject();        
	plumeJ.DeleteObject();        
	plumeC.DeleteObject();        
	plumeD.DeleteObject();                          
	m_pDC->SelectObject(m_pOldFont);        
	fntC.DeleteObject();
	fntD.DeleteObject();
	m_pDC->SetTextColor(clrOld);
	return 0;
} 
//________________________________________
void CDessin::Absisse(short NoGraphe,short Col,CString s)
{
	if (NoGraphe<0 || NoGraphe>5) NoGraphe=0;
	if (Col<0 || Col>5) Col=0;
	iD_Axes[0][NoGraphe]=Col;
	iN_Axes[0][NoGraphe]=s;
}
//________________________________________
void CDessin::Ordonnee(short NoGraphe,short Col,CString s)
{
	if (NoGraphe<0 || NoGraphe>5) NoGraphe=0;
	if (Col<0 || Col>5) Col=0;
	iD_Axes[1][NoGraphe]=Col;
	iN_Axes[1][NoGraphe]=s;
}
//________________________________________
void CDessin::InitZoom(void)
{                       
	m_fZoomXmi=-1e10;
	m_fZoomXma=1e10;
	m_fZoomYmi=-1e10;
	m_fZoomYma=1e10;
}
//________________________________________
void CDessin::Zoom(float xmi,float ymi,float xma,float yma)
{                       
	float r;
	if (xmi>xma)
	{
		r=xmi;
		xmi=xma;
		xma=r;
	}
	if (ymi>yma)
	{
		r=ymi;
		ymi=yma;
		yma=r;
	}
	m_fZoomXmi=xmi;
	m_fZoomXma=xma;
	m_fZoomYmi=ymi;
	m_fZoomYma=yma;
}
//________________________________________
void CDessin::MarqueDePointageVal(unsigned long coul,float x,float y)
{
	CString s;
	CFont 
		fntD,
		*m_pOldFont;  
	CBrush 
		*m_pOldBrush,
		brosseA,
		brosseB;
	COLORREF clrOld;	

	fntD.CreateFont((int)(m_ech*m_fHautTexte*0.85),0,0,0,FW_MEDIUM,FALSE,FALSE,FALSE,ANSI_CHARSET,OUT_DEFAULT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,DEFAULT_PITCH,"Arial");
	m_pOldFont=m_pDC->SelectObject(&fntD);	  
	m_pDC->SetTextAlign(TA_CENTER|TA_BOTTOM);							
	clrOld=m_pDC->SetTextColor(coul);
 	s.Format("%1.4f, %1.3f",x,y);

	x=x/factx;
	y=y/facty;
	x=(x-xori)*echx;
	y=(y-yori)*echy;
 	TextOut(x,y+1.5,s);

	brosseA.CreateSolidBrush(RGB(255,255,255));
	brosseB.CreateSolidBrush(coul);
	m_pOldBrush=m_pDC->SelectObject(&brosseA);
	Rectangle(x-0.8,y-0.8,x+0.8,y+0.8);
	m_pDC->SelectObject(&brosseB);
	Rectangle(x-0.6,y-0.6,x+0.6,y+0.6);

	m_pDC->SelectObject(m_pOldBrush);
	brosseA.DeleteObject();
	brosseB.DeleteObject();
	m_pDC->SelectObject(m_pOldFont);
	fntD.DeleteObject();                   
	m_pDC->SetTextColor(clrOld);
}
