// LaAcqDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "LaAcqDlg.h"
#include "BkDoc.h"
#include "chromex.h"
#include "conrsdlg.h"
#include "CandibusDX.h"
#include "EurosmartDX.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CLaAcqDlg dialog
CLaAcqDlg::CLaAcqDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLaAcqDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLaAcqDlg)
	m_sLambda1 = _T("");
	m_sLambda2 = _T("");
	m_sPasLambda = _T("");
	m_s = _T("");
	//}}AFX_DATA_INIT
}
void CLaAcqDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLaAcqDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDARRETER, m_btnArreter);
	DDX_Text(pDX, IDC_LAMBDA1, m_sLambda1);
	DDX_Text(pDX, IDC_LAMBDA2, m_sLambda2);
	DDX_Text(pDX, IDC_PAS, m_sPasLambda);
	DDX_Text(pDX, IDC_STATIC1, m_s);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CLaAcqDlg, CDialog)
	//{{AFX_MSG_MAP(CLaAcqDlg)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDARRETER, OnArreter)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CLaAcqDlg message handlers
void CLaAcqDlg::VerifPara()
{
	float r;                     
	CString s;
	if (m_fLambda1<350) m_fLambda1=350;
	if (m_fLambda1>1100) m_fLambda1=1100;
	if (m_fLambda2<350) m_fLambda2=350;
	if (m_fLambda2>1100) m_fLambda2=1100;
	if (fabs(m_fLambda1-m_fLambda2)<1) m_fLambda2=m_fLambda1+1;
	if (m_fLambda2<m_fLambda1)
	{
		r=m_fLambda1;
		m_fLambda1=m_fLambda2;
		m_fLambda2=r;
	}                                             
	if (m_fPasLambda<0.01) m_fPasLambda=0.01;
	if (m_fPasLambda>m_fLambda2-m_fLambda1) m_fPasLambda=m_fLambda2-m_fLambda1;
	m_iNbA=(short)(1+(m_fLambda2-m_fLambda1)/m_fPasLambda);  
	if (m_iNbA>m_pDoc->m_iNbMax)
	{
		m_fPasLambda=(m_fLambda2-m_fLambda1)/(m_pDoc->m_iNbMax-1);	
		s.Format("%1.2f",m_fPasLambda);
		sscanf(s,"%f",&m_fPasLambda);
	}
	m_iNbA=(int)(1+(m_fLambda2-m_fLambda1)/m_fPasLambda);  
}   
//__________________________________________________
void CLaAcqDlg::AffecteZ(void)
{
	m_sLambda1.Format("%1.2f",m_fLambda1);
	m_sLambda2.Format("%1.2f",m_fLambda2);
	m_sPasLambda.Format("%1.2f",m_fPasLambda);
	UpdateData(FALSE);
}
//__________________________________________________
void CLaAcqDlg::AffecteV(void)
{
	int i;
	float r;
	UpdateData(TRUE);
	i=sscanf(m_sLambda1,"%f",&r);if (i==1) m_fLambda1=r; else m_fLambda1=620; 
	i=sscanf(m_sLambda2,"%f",&r);if (i==1) m_fLambda2=r; else m_fLambda2=640;
	i=sscanf(m_sPasLambda,"%f",&r);if (i==1) m_fPasLambda=r; else m_fPasLambda=0.1;
}
//__________________________________________________
void CLaAcqDlg::Valider(void) 
{
	m_btnCancel.EnableWindow(TRUE);
	m_btnArreter.EnableWindow(TRUE);
	m_btnDemarrer.EnableWindow(TRUE);
	GetDlgItem(IDC_LAMBDA1)->EnableWindow(TRUE);
	GetDlgItem(IDC_LAMBDA2)->EnableWindow(TRUE);
	GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
}
//__________________________________________________
void CLaAcqDlg::Invalider(void) 
{
	m_btnCancel.EnableWindow(FALSE);
	m_btnArreter.EnableWindow(FALSE);
	m_btnDemarrer.EnableWindow(FALSE);
	GetDlgItem(IDC_LAMBDA1)->EnableWindow(FALSE);
	GetDlgItem(IDC_LAMBDA2)->EnableWindow(FALSE);
	GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
}
//__________________________________________________
BOOL CLaAcqDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_iNo=m_pDoc->m_iNo;
	CString s;
	float
		u,lambda;
	int
		lfe,lfs;
	BOOL ok;

	m_fLambda1=m_pDoc->m_fLambda1;
	m_fLambda2=m_pDoc->m_fLambda2;
	m_fPasLambda=m_pDoc->m_fPasLambda;
	VerifPara();
	m_sLambda1.Format("%1.2f",m_fLambda1);
	m_sLambda2.Format("%1.2f",m_fLambda2);
	m_sPasLambda.Format("%1.2f",m_fPasLambda);
	m_pCandi=new CCandibusDX();
	m_pEuro=new CEurosmartDX();
	switch (m_pApp->m_iTypeCarte)
	{
		case 0://Eurosmart
			u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,1);
			if (u==1e10)
			{
				m_s.Format("PROBLEME de lecture sur\ncarte Eurosmart !!");
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		case 1://Candibus
			u=m_pCandi->LitTension(m_pApp->m_radioVoie,1);
			if (u==1e10)
			{
				m_s.Format("PROBLEME de lecture sur\ncarte Candibus !!");
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		default:
			m_s.Format("Aucune carte A/N trouve !!\nAcquisitions simules...");
		break;
	}
	//Indicateur de progression, initialisation
	m_progress.SetRange(0,100);
	UpdateData(FALSE);               
	//Dure Timer
	m_iDuree=50;
	m_pApp->m_pChro->VideTampon();
	//Demande de configuration
	ok=m_pApp->m_pChro->WriteCom("QM\r");
	if (ok)
	{
		Invalider();
		m_iNb=0;SetTimer(1,m_iDuree,NULL);
	}
	return TRUE;
}
//__________________________________________________
void CLaAcqDlg::OnDemarrer() 
{
	short i,j;
	AffecteV();
	VerifPara();
	AffecteZ();

	m_btnDemarrer.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnArreter.EnableWindow(TRUE); 
	GetDlgItem(IDC_LAMBDA1)->EnableWindow(FALSE);
	GetDlgItem(IDC_LAMBDA2)->EnableWindow(FALSE);
	GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
	//Initialisation
 	for (i=0;i<m_pDoc->m_iNbMax;i++)
 	{              
	 	for (j=0;j<5;j++)
 		{              
 			m_pDoc->m_fT[i][j]=1e10;
		}
	}
	m_iNb=0;
	m_pDoc->m_iNb=0;
	m_pDoc->m_OKRendement=FALSE;
	m_fUMax=-1e10;
	SetTimer(2,50,NULL);
}
//__________________________________________________
void CLaAcqDlg::OnCancel() 
{
	delete m_pCandi;
	delete m_pEuro;
	//Libration console
	m_pApp->m_pChro->WriteCom("RL\r");
	if(m_pDoc->m_iNb!=0) m_pDoc->SetModifiedFlag(TRUE);
	m_pDoc->m_fLambda1=m_fLambda1;
	m_pDoc->m_fLambda2=m_fLambda2;
	m_pDoc->m_fPasLambda=m_fPasLambda;
	CDialog::OnCancel();
}
//__________________________________________________
void CLaAcqDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	BOOL ok;
	short 
		NbMax=20,
		nb,
		i,j,
		k,l;
	float u,lambda,
		r;

	j=(short)(pow(2,m_pApp->m_radioMoy));
	switch (nIDEvent)
	{
		//Lecture tension carte________________________
		case 0:
		break;
		//Paramtres du monochromateur: QM
		case 1://QM (4.36)
			m_iNb++;
			if (m_iNb>NbMax)
			{
				KillTimer(1);
				m_fL=m_pApp->m_pChro->QW();
				m_pDoc->m_iFE=m_iFE=m_pApp->m_pChro->QE();
				m_pDoc->m_iFS=m_iFS=m_pApp->m_pChro->QX();
				m_pApp->m_pChro->VideTampon();
				if (m_fL!=1e10 && m_iFE!=-1 && m_iFS!=-1)
				{
					m_s.Format("Lambda(nm): %1.2f\nFente d'entre (m): %d\nFente de sortie (m): %d",m_fL,m_iFE,m_iFS);
					m_pApp->m_pChro->VideTampon();
					Valider();
					m_btnArreter.EnableWindow(FALSE);
				}
				else
				{
					m_s.Format("Lambda (nm): ?\nFente d'entre (m): ?\nFente de sortie (m): ?");
					m_btnCancel.EnableWindow(TRUE);
				}
				UpdateData(FALSE);
				//Lecture tension
				//SetTimer(0,200,NULL);	
			}
		break;
		case 2://Acquisition
			//Pour augmenter la vitesse de scan, on fait 5 acquisitions par timer...
			nb=0;
			do
			{
				nb++;
				lambda=m_fLambda1+m_iNb*m_fPasLambda;
				if (m_iNb>=m_iNbA || m_iNb>=m_pDoc->m_iNbMax-1)
				{
					KillTimer(2);
					m_btnDemarrer.EnableWindow(TRUE);
					m_btnCancel.EnableWindow(TRUE);
					m_btnArreter.EnableWindow(FALSE);
					GetDlgItem(IDC_LAMBDA1)->EnableWindow(TRUE);
					GetDlgItem(IDC_LAMBDA2)->EnableWindow(TRUE);
					GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
					m_pDoc->UpdateAllViews(NULL);
					nb=5;
				}              
				else
				{
					//GW
					m_pApp->m_pChro->GW(lambda);
					//Lecture tension
					switch (m_pApp->m_iTypeCarte)
					{
						case 0://Eurosmart
							u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,j);
						break;
						case 1://Candibus
							u=m_pCandi->LitTension(m_pApp->m_radioVoie,j);
						break;
						default:
				  		u=-5+rand() % 11;
						break;
					}
					if (u!=1e10)
					{
						if (m_fUMax<u)
						{
							m_fUMax=u;m_fLambdaMax=lambda;
						}
						m_s.Format("Lambda(nm): %1.2f\nU[%d](V): %1.2f\nUMax=%1.2f V pour %1.2f nm",lambda,j,u,m_fUMax,m_fLambdaMax);
						//Ecriture tableau
						m_pDoc->m_fT[m_pDoc->m_iNb][0]=lambda;
						m_pDoc->m_fT[m_pDoc->m_iNb][1]=u;
						m_pDoc->m_iNb++;
					}
					else
					{	
						m_s.Format("Lambda(nm): %1.2f\nU[%d](V): ?",lambda,j);
					}
					//Indicateur de progression
					//Avancement en %
					i=(short)(100.0*(m_iNb+1)/m_iNbA);
					m_progress.SetPos(i);
					UpdateData(FALSE);
					m_iNb++;
				}
			}
			while(nb<5);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//__________________________________________________
void CLaAcqDlg::OnArreter() 
{
	KillTimer(2);	
	GetDlgItem(IDC_LAMBDA1)->EnableWindow(TRUE);
	GetDlgItem(IDC_LAMBDA2)->EnableWindow(TRUE);
	GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
	m_btnDemarrer.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	m_btnArreter.EnableWindow(FALSE); 
	m_pDoc->UpdateAllViews(NULL);
}
//__________________________________________________
void CLaAcqDlg::OnOK() 
{
	//CDialog::OnOK();
}
