// PilotDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "PilotDlg.h"
#include "bkdoc.h"
#include "calbdlg.h"
#include "chromex.h"
#include "conrsdlg.h"
#include "CandibusDX.h"
#include "EurosmartDX.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CPilotDlg dialog
CPilotDlg::CPilotDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPilotDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPilotDlg)
	m_sL = _T("");
	m_sFS = _T("");
	m_sFE = _T("");
	//}}AFX_DATA_INIT
}
void CPilotDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPilotDlg)
	DDX_Control(pDX, IDC_REG_FENTE_S, m_btnFenteS);
	DDX_Control(pDX, IDC_REG_FENTE_E, m_btnFenteE);
	DDX_Control(pDX, IDC_CALIBRER, m_btnCalibrer);
	DDX_Control(pDX, IDC_LAMBD, m_btnLambda);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDC_STEPUP, m_btnStepUp);
	DDX_Control(pDX, IDC_STEPDOWN, m_btnStepDown);
	DDX_Control(pDX, IDC_STATIC2, m_s2);
	DDX_Text(pDX, IDC_LAMBDA, m_sL);
	DDX_Text(pDX, IDC_FSOR, m_sFS);
	DDX_Text(pDX, IDC_FENT, m_sFE);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPilotDlg, CDialog)
	//{{AFX_MSG_MAP(CPilotDlg)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_LAMBD, OnLambd)
	ON_BN_CLICKED(IDC_STEPUP, OnStepup)
	ON_BN_CLICKED(IDC_STEPDOWN, OnStepdown)
	ON_BN_CLICKED(IDC_CALIBRER, OnCalibrer)
	ON_BN_CLICKED(IDC_REG_FENTE_E, OnRegFenteE)
	ON_BN_CLICKED(IDC_REG_FENTE_S, OnRegFenteS)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//////////////////////////////////////////
// CPilotDlg message handlers
BOOL CPilotDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	BOOL ok;
	float u;
	CString s;
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	m_pCandi=new CCandibusDX();
	m_pEuro=new CEurosmartDX();
	switch (m_pApp->m_iTypeCarte)
	{
		case 0://Eurosmart
			u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,1);
			if (u==1e10)
			{
				s.Format("PROBLEME de lecture sur\ncarte Eurosmart !!");
				m_s2.SetWindowText(s);	
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		case 1://Candibus
			u=m_pCandi->LitTension(m_pApp->m_radioVoie,1);
			if (u==1e10)
			{
				s.Format("PROBLEME de lecture sur\ncarte Candibus !!");
				m_s2.SetWindowText(s);	
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		default:
			s.Format("Aucune carte A/N trouve !!");
			m_s2.SetWindowText(s);	
		break;
	}
	m_pApp->m_pChro->VideTampon();
	//Demande de configuration
	ok=m_pApp->m_pChro->WriteCom("QM\r");
	if (ok)
	{
		Invalider();
		//m_btnCancel.EnableWindow(FALSE);
		m_iNb=0;SetTimer(1,50,NULL);
	}
	return TRUE;
}
//________________________________________
void CPilotDlg::OnOK() 
{
	//CDialog::OnOK();
}
//________________________________________
void CPilotDlg::OnCancel() 
{
	//Libration console
	m_pApp->m_pChro->WriteCom("RL\r");
  delete m_pCandi;
  delete m_pEuro;
	CDialog::OnCancel();
}
//________________________________________
void CPilotDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	BOOL ok;
	short
		i,j,
		k,l;
	float u,r;

	j=(short)(pow(2,m_pApp->m_radioMoy));
	switch (nIDEvent)
	{
		//Lecture tension carte_______________
		case 0:
			switch (m_pApp->m_iTypeCarte)
			{
				case 0://Eurosmart
					u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,j);
				break;
				case 1://Candibus
					u=m_pCandi->LitTension(m_pApp->m_radioVoie,j);
				break;
				default:
		  		u=1e10;
				break;
			}
			if (u==1e10)
				s.Format("U(V): ?");
			else	
				s.Format("U(V):%6.2f",u);
			m_s2.SetWindowText(s);	
		break;
		//Paramtres du monochromateur: QM
		case 1://QM (4.36)
			m_iNb++;
			if (m_iNb>20)//50*20=1000 ms
			{
				KillTimer(1);
				m_fL=m_pApp->m_pChro->QW();
				m_pDoc->m_iFE=m_iFE=m_pApp->m_pChro->QE();
				m_pDoc->m_iFS=m_iFS=m_pApp->m_pChro->QX();
				m_pApp->m_pChro->VideTampon();
				if (m_fL!=1e10 && m_iFE!=-1 && m_iFS!=-1)
				{
					m_sL.Format("%1.2f",m_fL);
					m_sFE.Format("%d",m_iFE);
					m_sFS.Format("%d",m_iFS);
					m_pApp->m_pChro->VideTampon();
				}
				else
				{
					m_sL.Format("?");
					m_sFS.Format("?");
					m_sFE.Format("?");
				}
				UpdateData(FALSE);
				Valider();
				//Lecture tension
				SetTimer(0,200,NULL);	
			}
		break;
		case 2://Temporisation
			m_iNb++;
			if (m_iNb>6)//50*6=300 ms
			{
				KillTimer(2);
				Valider();
			}
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CPilotDlg::Valider(void) 
{
	m_btnCancel.EnableWindow(TRUE);
	m_btnCalibrer.EnableWindow(TRUE);
	m_btnFenteE.EnableWindow(TRUE);
	m_btnFenteS.EnableWindow(TRUE);
	m_btnLambda.EnableWindow(TRUE);
	m_btnStepUp.EnableWindow(TRUE);
	m_btnStepDown.EnableWindow(TRUE);
	GetDlgItem(IDC_LAMBDA)->EnableWindow(TRUE);
	GetDlgItem(IDC_FENT)->EnableWindow(TRUE);
	GetDlgItem(IDC_FSOR)->EnableWindow(TRUE);
}
//________________________________________
void CPilotDlg::Invalider(void) 
{
	m_btnCancel.EnableWindow(FALSE);
	m_btnCalibrer.EnableWindow(FALSE);
	m_btnFenteE.EnableWindow(FALSE);
	m_btnFenteS.EnableWindow(FALSE);
	m_btnLambda.EnableWindow(FALSE);
	m_btnStepUp.EnableWindow(FALSE);
	m_btnStepDown.EnableWindow(FALSE);
	GetDlgItem(IDC_LAMBDA)->EnableWindow(FALSE);
	GetDlgItem(IDC_FENT)->EnableWindow(FALSE);
	GetDlgItem(IDC_FSOR)->EnableWindow(FALSE);
}
//________________________________________
void CPilotDlg::OnLambd() 
{
	//Clic sur le bouton "Goto lambda"	
	short i;
	float r;
	UpdateData(TRUE);
	i=sscanf(m_sL,"%f",&r);
	if (i==1)
	{
		if (r<300) r=300;
		if (r>1100) r=1100;
	}
	else
		r=632.8;
	if (r!=m_fL)
	{
		Invalider();
		m_fL=r;
		m_sL.Format("%1.2f",m_fL);
		UpdateData(FALSE);
		//GW
		if (m_pApp->m_pChro->GW(m_fL)==FALSE) AfxMessageBox("Erreur Goto Lambda !");
		m_iNb=0;SetTimer(2,50,NULL);
	}
}
//________________________________________
void CPilotDlg::OnStepup() 
{
	m_fL=m_fL+0.01;
	m_sL.Format("%1.2f",m_fL);
	UpdateData(FALSE);
	//GW
	Invalider();
	if (m_pApp->m_pChro->GW(m_fL)==FALSE) AfxMessageBox("Erreur Step Up !");
	m_iNb=0;SetTimer(2,50,NULL);
}
//________________________________________
void CPilotDlg::OnStepdown() 
{
	m_fL=m_fL-0.01;
	m_sL.Format("%1.2f",m_fL);
	UpdateData(FALSE);
	//GW
	Invalider();
	if (m_pApp->m_pChro->GW(m_fL)==FALSE) AfxMessageBox("Erreur Step Down !");
	Sleep(300);
	Valider();
}
//________________________________________
void CPilotDlg::OnCalibrer() 
{
	BOOL ok;
	//Arrt lecture tension
	KillTimer(0);	
	Invalider();
	CCalbDlg d;
	if (d.DoModal()==IDOK)
	{
		//Demande de configuration
		ok=m_pApp->m_pChro->WriteCom("QM\r");
		if (ok)
		{
			Invalider();
			//m_btnCancel.EnableWindow(FALSE);
			m_iNb=0;SetTimer(1,50,NULL);
		}
	}
	//Lecture tension
	SetTimer(0,200,NULL);		
	Valider();
}
//________________________________________
void CPilotDlg::OnRegFenteE() 
{
	short i;
	UpdateData(TRUE);
	//Fente d'entre
	i=sscanf(m_sFE,"%d",&m_iFE);
	if (i==1)
	{
		if (m_iFE<0) m_iFE=0;
		if (m_iFE>2000) m_iFE=2000;
	}
	else
		m_iFE=100;
	m_sFE.Format("%d",m_iFE);
	UpdateData(FALSE);
	//AE
	Invalider();
	if (m_pApp->m_pChro->AE(m_iFE)==FALSE) AfxMessageBox("Erreur rglage fente d'entre !");
	m_iNb=0;SetTimer(2,50,NULL);
}
//________________________________________
void CPilotDlg::OnRegFenteS() 
{
	short i;
	BOOL ok;
	UpdateData(TRUE);
	//Fente de sortie
	i=sscanf(m_sFS,"%d",&m_iFS);
	if (i==1)
	{
		if (m_iFS<0) m_iFS=0;
		if (m_iFS>2000) m_iFS=2000;
	}
	else
		m_iFS=100;
	m_sFS.Format("%d",m_iFS);
	UpdateData(FALSE);

	//AX
	Invalider();
	if (m_pApp->m_pChro->AX(m_iFS)==FALSE) AfxMessageBox("Erreur rglage fente de sortie !");
	m_iNb=0;SetTimer(2,50,NULL);
}
