// BkDoc.h : interface of the CBkDoc class
//
/////////////////////////////////////////////////////////////////////////////
class CBkDoc : public CDocument
{
protected: // create from serialization only
	CBkDoc();
	DECLARE_DYNCREATE(CBkDoc)

// Attributes
public:
	class CBkApp* m_pApp;		//Pointeur sur l'application affect dans CBkView::OnInitialUpdate
	class CBkView* m_pView;	//Pointeur sur la vue
	class CWnd* m_pWnd;			//Pointeur sur la fentre
	short m_iNo;						//N fentre

	//Tableau de mesures______________________________
	short 
		m_iNbMax,				//Nb. maxi d'acquisitions  
		m_iNb;					//Nb. effectif d'aquisitions
	float (*m_fT)[5];	//Pointeur sur un tableau de float  6 colonnes
	//Fentre graphique_______________________________
	float
		m_fXmi,m_fYmi,m_fXma,m_fYma,
		m_fEchx,m_fEchy,m_fXori,m_fYori,m_fFactx,m_fFacty;
	//Coordonns souris_______________________________
	float
		m_fX,m_fY,m_fDx,m_fDy;
	//Acquisition_____________________________________
 	short
 		m_radioTypeAcq,			//Type d'acquisition 0:lambda, 1:sigma, ...    
 		m_radioTypeScan,		//Type scan 0:rfrence, 1:chantillon, ...    
 		m_iTypeGr;					//Types de graphe  visualiser
 	float
 		m_fLambda1,m_fLambda2,m_fPasLambda,	
 		m_fSigma1,m_fSigma2,m_fPasSigma,
 		m_fLambdaCalb;
	//Fentes
	short m_iFS,m_iFE;

	BOOL m_OKRendement;

// Operations
public:
	void DimensionnerFenetre(short,short);
	void LigneColonne(short*,short*);
	BOOL FFTRap(float (*m_fT)[5],int *n);
	float Sensibilite(float lambda);
	float Efficacite(float lambda);

protected:
	//Structure pour calcul FFT
	struct enreg
	{
		float
			RealF,ImagF;
	};
	void l_enreg(FILE *f_dir,unsigned int i,struct enreg *e);
	void e_enreg(FILE *f_dir,unsigned int i,struct enreg *e);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CBkDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
