// BkView.h : interface of the CBkView class
//
/////////////////////////////////////////////////////////////////////////////
class CBkView : public CView
{
protected: // create from serialization only
	CBkView();
	DECLARE_DYNCREATE(CBkView)

// Attributes
protected:
	class CBkApp *m_pApp;
	//Accroche ccord. souris au graphe________________
	BOOL m_OKAccro;
	short
		m_iXd,m_iYd,
		m_iCol,m_iLig,m_iNo;
	//Zoom____________________________________________
	short m_iZoom;
	float
		m_fZoomXmi,m_fZoomXma,m_fZoomYmi,m_fZoomYma;
	void InitZoom(void);
	void Zoom(float xmi,float ymi,float xma,float yma);
	CRectTracker m_tracker;
	void InitTracker(void);
	void TraceRectTracker(CDC *pDC);


public:
	CBkDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CBkView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnInitialUpdate();
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CBkView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	//Changement de coordonnes sens 1
	void PIX_FEN(short xp,short yp,float *xmm,float *ymm);
	void FEN_GR(float xmm,float ymm,float *x,float *y);
	void GR_TAB(float x,float y,float *xt,float *yt);
	//Changement de coordonnes sens 2
	void TAB_GR(float xt,float yt,float *x,float *y);
	void GR_FEN(float x,float y,float *xmm,float *ymm);
	void FEN_PIX(float xmm,float ymm,short *xp,short *yp);
	//Coordonnes souris______________________________
	BOOL AccrocheGraphe(CPoint point,short *ecart,short *no,short *li,short *co);
	void MajZone(short x1,short y1,short x2,short y2);
	void InitSouris();

// Generated message map functions
protected:
	//{{AFX_MSG(CBkView)
	afx_msg void OnUpdateFileNew(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnUpdateZoom(CCmdUI* pCmdUI);
	afx_msg void OnZoom();
	afx_msg void OnZoomTout();
	afx_msg void OnPortserie();
	afx_msg void OnUpdateFicTxt(CCmdUI* pCmdUI);
	afx_msg void OnFicTxt();
	afx_msg void OnUpdateTestSerie(CCmdUI* pCmdUI);
	afx_msg void OnTestSerie();
	afx_msg void OnUpdatePilotage(CCmdUI* pCmdUI);
	afx_msg void OnPilotage();
	afx_msg void OnUpdateGrapheSelection(CCmdUI* pCmdUI);
	afx_msg void OnGrapheSelection();
	afx_msg void OnUpdateTypeAcq(CCmdUI* pCmdUI);
	afx_msg void OnTypeAcq();
	afx_msg void OnUpdateAcquerir(CCmdUI* pCmdUI);
	afx_msg void OnAcquerir();
	afx_msg void OnRendement();
	afx_msg void OnCarteAn();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in BkView.cpp
inline CBkDoc* CBkView::GetDocument()
   { return (CBkDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////
