// DeFaDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "DeFaDlg.h"
#include "BkDoc.h"
#include "chromex.h"
#include "conrsdlg.h"
#include "Candibus.h"
#include "Eurosmart.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CDeFaDlg dialog
CDeFaDlg::CDeFaDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDeFaDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDeFaDlg)
	m_sLambda1 = _T("");
	m_sLambda2 = _T("");
	m_sPasLambda = _T("");
	m_s = _T("");
	m_radioTypeScan = -1;
	//}}AFX_DATA_INIT
}
void CDeFaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDeFaDlg)
	DDX_Control(pDX, IDDEMARRER, m_btnDemarrer);
	DDX_Control(pDX, IDCANCEL, m_btnCancel);
	DDX_Control(pDX, IDARRETER, m_btnArreter);
	DDX_Control(pDX, IDC_PROGRES, m_progress);
	DDX_Text(pDX, IDC_LAMBDA1, m_sLambda1);
	DDX_Text(pDX, IDC_LAMBDA2, m_sLambda2);
	DDX_Text(pDX, IDC_PAS, m_sPasLambda);
	DDX_Text(pDX, IDC_STATIC1, m_s);
	DDX_Radio(pDX, IDC_TYPE_SCAN, m_radioTypeScan);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CDeFaDlg, CDialog)
	//{{AFX_MSG_MAP(CDeFaDlg)
	ON_BN_CLICKED(IDDEMARRER, OnDemarrer)
	ON_BN_CLICKED(IDARRETER, OnArreter)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CDeFaDlg message handlers
void CDeFaDlg::VerifPara()
{
	float r;                     
	CString s;
	if (m_fLambda1<350) m_fLambda1=350;
	if (m_fLambda1>1100) m_fLambda1=1100;
	if (m_fLambda2<350) m_fLambda2=350;
	if (m_fLambda2>1100) m_fLambda2=1100;
	if (fabs(m_fLambda1-m_fLambda2)<1) m_fLambda2=m_fLambda1+1;
	if (m_fLambda2<m_fLambda1)
	{
		r=m_fLambda1;
		m_fLambda1=m_fLambda2;
		m_fLambda2=r;
	}                                             
	if (m_fPasLambda<0.01) m_fPasLambda=0.01;
	if (m_fPasLambda>m_fLambda2-m_fLambda1) m_fPasLambda=m_fLambda2-m_fLambda1;
	m_iNbA=(short)(1+(m_fLambda2-m_fLambda1)/m_fPasLambda);  
	if (m_iNbA>m_pDoc->m_iNbMax)
	{
		m_fPasLambda=(m_fLambda2-m_fLambda1)/(m_pDoc->m_iNbMax-1);	
		s.Format("%1.2f",m_fPasLambda);
		sscanf(s,"%f",&m_fPasLambda);
	}
	m_iNbA=(int)(1+(m_fLambda2-m_fLambda1)/m_fPasLambda);  
}   
//________________________________________
void CDeFaDlg::AffecteZ(void)
{
	m_sLambda1.Format("%1.2f",m_fLambda1);
	m_sLambda2.Format("%1.2f",m_fLambda2);
	m_sPasLambda.Format("%1.2f",m_fPasLambda);
	UpdateData(FALSE);
}
//________________________________________
void CDeFaDlg::AffecteV(void)
{
	int i;
	float r;
	UpdateData(TRUE);
	i=sscanf(m_sLambda1,"%f",&r);if (i==1) m_fLambda1=r; else m_fLambda1=620; 
	i=sscanf(m_sLambda2,"%f",&r);if (i==1) m_fLambda2=r; else m_fLambda2=640;
	i=sscanf(m_sPasLambda,"%f",&r);if (i==1) m_fPasLambda=r; else m_fPasLambda=0.1;
}
//________________________________________
BOOL CDeFaDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	CMDIChildWnd *pChild=((CMDIFrameWnd*)(AfxGetApp()->m_pMainWnd))->MDIGetActive();
	if (pChild) m_pDoc=(CBkDoc*)pChild->GetActiveDocument(); else m_pDoc=NULL;
	m_iNo=m_pDoc->m_iNo;
	CString s;
	float
		u,lambda;
	int
		lfe,lfs;
	BOOL ok;

	m_fLambda1=m_pDoc->m_fLambda1;
	m_fLambda2=m_pDoc->m_fLambda2;
	m_fPasLambda=m_pDoc->m_fPasLambda;
	m_radioTypeScan=m_pDoc->m_radioTypeScan;
	VerifPara();
	m_sLambda1.Format("%1.2f",m_fLambda1);
	m_sLambda2.Format("%1.2f",m_fLambda2);
	m_sPasLambda.Format("%1.2f",m_fPasLambda);
	m_pCandi=new CCandibus();
	m_pEuro=new CEurosmart();
	switch (m_pApp->m_iTypeCarte)
	{
		case 0://Eurosmart
			u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,1);
			if (u==1e10)
			{
				m_s.Format("PROBLEME de lecture sur\ncarte Eurosmart !!");
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		case 1://Candibus
			u=m_pCandi->LitTension(m_pApp->m_radioVoie,1);
			if (u==1e10)
			{
				m_s.Format("PROBLEME de lecture sur\ncarte Candibus !!");
				m_pApp->m_iTypeCarte=-1;
			}
		break;
		default:
			m_s.Format("Aucune carte A/N trouve !!\nAcquisitions simules...");
		break;
	}
	//Indicateur de progression, initialisation
	m_progress.SetRange(0,100);
	UpdateData(FALSE);               
	//Dure Timer
	m_iDuree=50;
	m_pApp->m_pChro->VideTampon();
	//Demande de configuration
	ok=m_pApp->m_pChro->WriteCom("QM\r");
	if (ok)
	{
		//Invalider tout...
		m_btnCancel.EnableWindow(FALSE);
		m_btnArreter.EnableWindow(FALSE);
		m_btnDemarrer.EnableWindow(FALSE);
		GetDlgItem(IDC_LAMBDA1)->EnableWindow(FALSE);
		GetDlgItem(IDC_LAMBDA2)->EnableWindow(FALSE);
		GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
		GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(FALSE);
		GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(FALSE);
		m_iNb=0;SetTimer(1,m_iDuree,NULL);
	}
	return TRUE;
}
//________________________________________
void CDeFaDlg::OnCancel() 
{
	KillTimer(0);
	delete m_pCandi;
	delete m_pEuro;
	//Libration console
	m_pApp->m_pChro->WriteCom("RL\r");
	if(m_pDoc->m_iNb!=0) m_pDoc->SetModifiedFlag(TRUE);
	UpdateData(TRUE);
	m_pDoc->m_fLambda1=m_fLambda1;
	m_pDoc->m_fLambda2=m_fLambda2;
	m_pDoc->m_fPasLambda=m_fPasLambda;
	m_pDoc->m_radioTypeScan=m_radioTypeScan;
	CDialog::OnCancel();
}
//________________________________________
void CDeFaDlg::OnDemarrer() 
{
	KillTimer(0),
	AffecteV();
	VerifPara();
	AffecteZ();
	m_btnDemarrer.EnableWindow(FALSE);
	m_btnCancel.EnableWindow(FALSE);
	m_btnArreter.EnableWindow(TRUE); 
	GetDlgItem(IDC_LAMBDA1)->EnableWindow(FALSE);
	GetDlgItem(IDC_LAMBDA2)->EnableWindow(FALSE);
	GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
	GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(FALSE);
	GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(FALSE);
	m_iNb=0;
	m_pDoc->m_iNb=0;
	m_pDoc->m_OKRendement=FALSE;
	m_fUMax=-1e10;
	SetTimer(2,50,NULL);
}
//________________________________________
void CDeFaDlg::OnArreter() 
{
	KillTimer(2);	
	GetDlgItem(IDC_LAMBDA1)->EnableWindow(TRUE);
	GetDlgItem(IDC_LAMBDA2)->EnableWindow(TRUE);
	GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
	GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(TRUE);
	GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(TRUE);
	m_btnDemarrer.EnableWindow(TRUE);
	m_btnCancel.EnableWindow(TRUE);
	m_btnArreter.EnableWindow(FALSE); 
	if (m_radioTypeScan==0)
		m_pDoc->m_iTypeGr=1;//Rfrence
	else
		m_pDoc->m_iTypeGr=2;//Echantillon
	m_pDoc->UpdateAllViews(NULL);
	SetTimer(0,200,NULL);
}
//________________________________________
void CDeFaDlg::OnTimer(UINT nIDEvent) 
{
	CString s;
	BOOL ok;
	short 
		NbMax=20,
		nb,
		i,j,
		k,l;
	float u,lambda,
		r;

	j=(short)(pow(2,m_pApp->m_radioMoy));

	switch (nIDEvent)
	{
		case 0://Mise  jour bote de dialogue
			UpdateData(TRUE);
			GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(TRUE);
			GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(TRUE);
			if (m_radioTypeScan==0)
			{
				GetDlgItem(IDC_LAMBDA1)->EnableWindow(TRUE);
				GetDlgItem(IDC_LAMBDA2)->EnableWindow(TRUE);
				GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
			}
			else
			{
				//Echantillon
				GetDlgItem(IDC_LAMBDA1)->EnableWindow(FALSE);
				GetDlgItem(IDC_LAMBDA2)->EnableWindow(FALSE);
				GetDlgItem(IDC_PAS)->EnableWindow(FALSE);
			}
			UpdateData(FALSE);
		break;
		case 1://QM (4.36)
			m_iNb++;
			if (m_iNb>NbMax)
			{
				KillTimer(1);
				m_fL=m_pApp->m_pChro->QW();
				m_pDoc->m_iFE=m_iFE=m_pApp->m_pChro->QE();
				m_pDoc->m_iFS=m_iFS=m_pApp->m_pChro->QX();
				m_pApp->m_pChro->VideTampon();
				if (m_fL!=1e10 && m_iFE!=-1 && m_iFS!=-1)
				{
					m_s.Format("Lambda(nm): %1.2f\nFente d'entre (m): %d\nFente de sortie (m): %d",m_fL,m_iFE,m_iFS);
					m_pApp->m_pChro->VideTampon();
					m_btnArreter.EnableWindow(FALSE);
					m_btnDemarrer.EnableWindow(TRUE);
				}
				else
				{
					m_s.Format("Lambda (nm): ?\nFente d'entre (m): ?\nFente de sortie (m): ?");
				}
				SetTimer(0,200,NULL),
				m_btnCancel.EnableWindow(TRUE);
				UpdateData(FALSE);
			}
		break;
		case 2://Acquisition
			//Pour augmenter la vitesse de scan, on fait 5 acquisitions par timer...
			nb=0;
			do
			{
				nb++;
				lambda=m_fLambda1+m_iNb*m_fPasLambda;
				if (m_iNb>=m_iNbA || m_iNb>=m_pDoc->m_iNbMax-1)
				{
					KillTimer(2);
					m_btnDemarrer.EnableWindow(TRUE);
					m_btnCancel.EnableWindow(TRUE);
					m_btnArreter.EnableWindow(FALSE);
					GetDlgItem(IDC_LAMBDA1)->EnableWindow(TRUE);
					GetDlgItem(IDC_LAMBDA2)->EnableWindow(TRUE);
					GetDlgItem(IDC_PAS)->EnableWindow(TRUE);
					GetDlgItem(IDC_TYPE_SCAN)->EnableWindow(TRUE);
					GetDlgItem(IDC_TYPE_SCAN2)->EnableWindow(TRUE);
					if (m_radioTypeScan==0)
						m_pDoc->m_iTypeGr=1;//Rfrence
					else
						m_pDoc->m_iTypeGr=2;//Echantillon
					m_pDoc->UpdateAllViews(NULL);
					nb=5;
					SetTimer(0,200,NULL);
				}              
				else
				{
					//GW
					m_pApp->m_pChro->GW(lambda);
					//Lecture tension
					switch (m_pApp->m_iTypeCarte)
					{
						case 0://Eurosmart
							u=m_pEuro->LitTension(m_pApp->m_radioVoie,m_pApp->m_radioTypeAcq,j);
						break;
						case 1://Candibus
							u=m_pCandi->LitTension(m_pApp->m_radioVoie,j);
						break;
						default:
				  		u=-5+rand() % 11;
						break;
					}
					if (u!=1e10)
					{
						if (m_fUMax<u)
						{
							m_fUMax=u;m_fLambdaMax=lambda;
						}
						m_s.Format("Lambda(nm): %1.2f\nU[%d](V): %1.2f\nUMax=%1.2f V pour %1.2f nm",lambda,j,u,m_fUMax,m_fLambdaMax);
						//Ecriture tableau
						m_pDoc->m_fT[m_pDoc->m_iNb][0]=lambda;
				  	if (m_radioTypeScan==0)
	  				{
							//Rfrence
							m_pDoc->m_fT[m_pDoc->m_iNb][1]=u;
						}
						else
	  				{
							//Echantillon
							m_pDoc->m_fT[m_pDoc->m_iNb][2]=u;
						}
						m_pDoc->m_iNb++;
					}
					else
					{	
						m_s.Format("Lambda(nm): %1.2f\nU[%d](V): ?",lambda,j);
					}
					//Indicateur de progression
					//Avancement en %
					i=(short)(100.0*(m_iNb+1)/m_iNbA);
					m_progress.SetPos(i);
					UpdateData(FALSE);
					m_iNb++;
				}
			}
			while(nb<5);
		break;
	}
	CDialog::OnTimer(nIDEvent);
}
//________________________________________
void CDeFaDlg::OnOK() 
{
	//CDialog::OnOK();
}
