// SelGrDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "SelGrDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CSelGrDlg dialog
CSelGrDlg::CSelGrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelGrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelGrDlg)
	m_OKRef = FALSE;
	m_OKEchan = FALSE;
	m_OKCalcul = FALSE;
	m_radioDensite = -1;
	m_radioBiref = -1;
	m_OKRendement = FALSE;
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CSelGrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelGrDlg)
	DDX_Check(pDX, IDC_REF, m_OKRef);
	DDX_Check(pDX, IDC_ECH, m_OKEchan);
	DDX_Check(pDX, IDC_CALCUL, m_OKCalcul);
	DDX_Radio(pDX, IDC_DENSITE, m_radioDensite);
	DDX_Radio(pDX, IDC_BIREF, m_radioBiref);
	DDX_Check(pDX, IDC_RENDEMENT, m_OKRendement);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelGrDlg, CDialog)
	//{{AFX_MSG_MAP(CSelGrDlg)
	ON_BN_CLICKED(IDC_CALCUL, OnCalcul)
	ON_BN_CLICKED(IDC_FFT, OnFft)
	ON_BN_CLICKED(IDC_REF, OnRef)
	ON_BN_CLICKED(IDC_ECH, OnEch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CSelGrDlg message handlers
BOOL CSelGrDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	if (m_pDoc->m_iTypeGr & 1)
	{
		//Bit 0:Rfrence
		m_OKRef=TRUE;
	}	
	if (m_pDoc->m_iTypeGr & 2)
	{
		//Bit 1:Echantillon
		m_OKEchan=TRUE;
	}	
	if (m_pDoc->m_iTypeGr & 4)
	{
		//Bit 2:Calculs, voir ci-dessous
		m_OKCalcul=TRUE;
	}	
	//Bit 3: 0:Densit, 1:Facteur de transmission
	if (m_pDoc->m_iTypeGr & 8)
		m_radioDensite=1;//Fact. de trans
	else	
		m_radioDensite=0;//Densit

	//Bit 4: 0:Biref, 1:FFT
	if (m_pDoc->m_iTypeGr & 16)
		m_radioBiref=1;//FFT
	else	
		m_radioBiref=0;//Biref

	m_OKRendement=m_pDoc->m_OKRendement;
	UpdateData(FALSE);

	if (m_pDoc->m_radioTypeAcq==0)//Lambda
	{
		GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_REF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_ECH)->EnableWindow(FALSE);        
		GetDlgItem(IDC_CALCUL)->EnableWindow(FALSE);        
	}
 	if (m_OKCalcul)
	{
		switch (m_pDoc->m_radioTypeAcq)
		{
			case 2://Densit
				GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
			break;	 
			case 3://Birfringence
				GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
			break;	 
		} 
	} 
	else
	{
		GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
	}
	return TRUE;
}
//________________________________________
void CSelGrDlg::OnOK() 
{
	short i;
	float 
		lambda,r;
	
	GetDlgItem(IDC_DENSITE)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FACT)->EnableWindow(TRUE);        
	GetDlgItem(IDC_BIREF)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FFT)->EnableWindow(TRUE);        
	UpdateData(TRUE);
	m_pDoc->m_iTypeGr=0;	
	if (m_OKRef) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+1; 					//Bit 0  1
	if (m_OKEchan) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+2; 				//Bit 1  1
	if (m_OKCalcul) m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+4; 				//Bit 2  1

	if (m_pDoc->m_iTypeGr==0) m_pDoc->m_iTypeGr=2;//Si aucun graphe slectionn -> Echantillon

	if (m_pDoc->m_radioTypeAcq==0)
	{   
    //LAMBDA
		if (m_pDoc->m_OKRendement!=m_OKRendement)
		{
			//Il faut recalculer la deuxime colonne
	  	for (i=0;i<m_pDoc->m_iNb;i++)
			{
				if (m_pDoc->m_fT[i][0]!=1e10 && m_pDoc->m_fT[i][1]!=1e10)
				{
					lambda=m_pDoc->m_fT[i][0];
					r=m_pDoc->Sensibilite(lambda)*m_pDoc->Efficacite(lambda);
					if (m_OKRendement)
						m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]/r;
					else
						m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]*r;
				}	
			}
		} 
  }  
  else
	if (m_pDoc->m_radioTypeAcq==1)
	{   
		//Sigma trait dans boite de dialogue spare CSigGrDlg
		//Ce n'est pas la mme bote de dialogue !
	}
	else
	if (m_radioDensite==1 && m_pDoc->m_radioTypeAcq==2) 
	{
		//FACTEUR DE TRANSMISSION EN LAMBDA
		//Bit 3  1 de m_iTypeGr pour fact. de transmission
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+8;	

		if (m_pDoc->m_OKRendement!=m_OKRendement)
		{
	  	for (i=0;i<m_pDoc->m_iNb;i++)
			{
				lambda=m_pDoc->m_fT[i][0];
				if (lambda!=1e10)
				{
					r=m_pDoc->Sensibilite(lambda)*m_pDoc->Efficacite(lambda);
					if (m_OKRendement)
					{              
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]/r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]/r;
					}	
					else
					{                   
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]*r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]*r;
					}	
				}	
			}
		} 

		//Calcul facteur de transmission en colonne 4
	  for (i=0;i<m_pDoc->m_iNb;i++)
  	{
  		//Calcul du facteur de transmission=Ech./Ref.
  		if (fabs(m_pDoc->m_fT[i][1]>1e-8) && m_pDoc->m_fT[i][1]!=1e10 && m_pDoc->m_fT[i][2]!=1e10)
  		{
  			m_pDoc->m_fT[i][4]=(float)(m_pDoc->m_fT[i][2]/m_pDoc->m_fT[i][1]);
  		}
  		else
  		{ 
  			m_pDoc->m_fT[i][4]=1e10;
  		} 
    }
	}	
	else
	if (m_radioDensite==0 && m_pDoc->m_radioTypeAcq==2) 
	{
		//DENSITE OPTIQUE EN LAMBDA
		//Le bit 3 de m_iTypeGr reste  0 pour densit

		if (m_pDoc->m_OKRendement!=m_OKRendement)
		{
	  	for (i=0;i<m_pDoc->m_iNb;i++)
			{
				lambda=m_pDoc->m_fT[i][0];
				if (lambda!=1e10)
				{
					r=m_pDoc->Sensibilite(lambda)*m_pDoc->Efficacite(lambda);
					if (m_OKRendement)
					{              
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]/r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]/r;
					}	
					else
					{                   
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]*r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]*r;
					}	
				}	
			}
		} 

		//Calcul densit optique en colonne 3
	  for (i=0;i<m_pDoc->m_iNb;i++)
  	{
			//Calcul de la densit optique=log10(Ref./Ech.) en colonne 3
  		if (fabs(m_pDoc->m_fT[i][2]>1e-8) && m_pDoc->m_fT[i][1]/m_pDoc->m_fT[i][2]>0 && m_pDoc->m_fT[i][1]!=1e10 && m_pDoc->m_fT[i][2]!=1e10)
  		{
  			m_pDoc->m_fT[i][3]=(float)(log10(m_pDoc->m_fT[i][1]/m_pDoc->m_fT[i][2]));
  		}
  		else
  		{ 
  			m_pDoc->m_fT[i][3]=1e10;
  		} 
    }
	}
	//________________________________________________
	if (m_radioBiref==1 && m_pDoc->m_radioTypeAcq==3) 
	{
		//FFT EN SIGMA                   
		if (m_pDoc->m_OKRendement!=m_OKRendement)
		{
	  	for (i=0;i<m_pDoc->m_iNb;i++)
			{
				if (m_pDoc->m_fT[i][0]!=1e10)
				{
					lambda=(float)(1E6/m_pDoc->m_fT[i][0]);
					r=m_pDoc->Sensibilite(lambda)*m_pDoc->Efficacite(lambda);
					if (m_OKRendement)
					{              
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]/r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]/r;
					}	
					else
					{                   
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]*r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]*r;
					}	
				}	
			}
		} 

		m_s1="Calcul FFT en cours. Patientez...";
		UpdateData(FALSE);
		GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_REF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_ECH)->EnableWindow(FALSE);        
		GetDlgItem(IDC_CALCUL)->EnableWindow(FALSE);        
		GetDlgItem(IDC_STATIC2)->EnableWindow(FALSE);        
		GetDlgItem(IDC_RENDEMENT)->EnableWindow(FALSE);        
		//Bit 4  1 de m_iTypeGr pour FFT
		m_pDoc->m_iTypeGr=m_pDoc->m_iTypeGr+16;
	  for (i=0;i<m_pDoc->m_iNb;i++)
  	{
			//Affectation partie relle FFT en colonne 3
  		if (m_pDoc->m_fT[i][1]!=0 && m_pDoc->m_fT[i][1]!=1e10 && m_pDoc->m_fT[i][2]!=1e10)
  			//Ech./Ref.
  			m_pDoc->m_fT[i][3]=m_pDoc->m_fT[i][2]/m_pDoc->m_fT[i][1];
  		else
  			m_pDoc->m_fT[i][3]=0; //Nul si division par zro
			//Affectation partie imaginaire FFT en colonne 4
    	m_pDoc->m_fT[i][4]=0;		//Partie imaginaire nulle
    }
		//Calcul FFT   
		int nb;
		//Nb. d'chantillons multiple de 256...
		if (m_pDoc->m_iNb>=1000)
		{
			nb=1024;
			//On complte ventuellement  1024
			for (i=m_pDoc->m_iNb;i<1024;i++)
			{
  			m_pDoc->m_fT[i][3]=0;
	    	m_pDoc->m_fT[i][4]=0;
			}
		}
		if (m_pDoc->m_iNb>=512 && m_pDoc->m_iNb<1000) nb=512;
		if (m_pDoc->m_iNb>=256 && m_pDoc->m_iNb<512) nb=256;
		if (m_pDoc->m_iNb<256) 
		{
			nb=256;
			//On complte ventuellement  256
			for (i=m_pDoc->m_iNb;i<256;i++)
			{
  			m_pDoc->m_fT[i][3]=0;
	    	m_pDoc->m_fT[i][4]=0;
			}
		}	
		if (m_pDoc->FFTRap(m_pDoc->m_fT,&nb)==TRUE)
		{
			//Calcul module en colonne 4
			for (i=0;i<nb;i++)
			{
				m_pDoc->m_fT[i][4]=(float)(sqrt(pow(m_pDoc->m_fT[i][3],2)+pow(m_pDoc->m_fT[i][4],2)));
			}
			//Graduation colonne 3 en delta en tenant compte plage souhaite
			for (i=0;i<nb;i++)
			{
				m_pDoc->m_fT[i][3]=(float)(1/m_pDoc->m_fPasSigma-i/((nb-1)*m_pDoc->m_fPasSigma));
			}


			//Ecriture ordre inverse sur 100 points 
			float r,r1;
			int k=0;
			for (i=nb-1;i>nb-1-100;i--)
			{
				r=m_pDoc->m_fT[i][3];
				r1=m_pDoc->m_fT[i][4];
				m_pDoc->m_fT[k][3]=r;
				m_pDoc->m_fT[k][4]=r1;
				k++;
			} 
			
			//Limitation sur les 100 premiers points...  
			for (i=100;i<m_pDoc->m_iNb;i++)
			{
				m_pDoc->m_fT[i][3]=1e10;
				m_pDoc->m_fT[i][4]=1e10;
			} 
		
		}
		else
		{
			//Le calcul FFT a chou  cause de l'ouverture fichier .$$$
			for (i=0;i<m_pDoc->m_iNb;i++)
			{
				m_pDoc->m_fT[i][3]=1e10;
				m_pDoc->m_fT[i][4]=1e10;
			}
		}
		GetDlgItem(IDC_DENSITE)->EnableWindow(TRUE);        
		GetDlgItem(IDC_FACT)->EnableWindow(TRUE);        
		GetDlgItem(IDC_BIREF)->EnableWindow(TRUE);        
		GetDlgItem(IDC_FFT)->EnableWindow(TRUE);        
		GetDlgItem(IDC_REF)->EnableWindow(TRUE);        
		GetDlgItem(IDC_ECH)->EnableWindow(TRUE);        
		GetDlgItem(IDC_CALCUL)->EnableWindow(TRUE);        
		GetDlgItem(IDC_STATIC2)->EnableWindow(TRUE);        
		GetDlgItem(IDC_RENDEMENT)->EnableWindow(TRUE);        
	}
	else
	if (m_radioBiref==0 && m_pDoc->m_radioTypeAcq==3) 
	{ 
		//BIREFRINGENCE EN SIGMA
		//Le bit 4 de m_iTypeGr reste  0 pour birfringence

		if (m_pDoc->m_OKRendement!=m_OKRendement)
		{
	  	for (i=0;i<m_pDoc->m_iNb;i++)
			{
				if (m_pDoc->m_fT[i][0]!=1e10)
				{
					lambda=(float)(1E6/m_pDoc->m_fT[i][0]);
					r=m_pDoc->Sensibilite(lambda)*m_pDoc->Efficacite(lambda);
					if (m_OKRendement)
					{              
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]/r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]/r;
					}	
					else
					{                   
						if (m_pDoc->m_fT[i][1]!=1e10) m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]*r;
						if (m_pDoc->m_fT[i][2]!=1e10) m_pDoc->m_fT[i][2]=m_pDoc->m_fT[i][2]*r;
					}	
				}	
			}
		} 
		//Calcul birfringence en colonne 3
	  for (i=0;i<m_pDoc->m_iNb;i++)
  	{
  		if (m_pDoc->m_fT[i][1]!=0 && m_pDoc->m_fT[i][1]!=1e10 && m_pDoc->m_fT[i][2]!=1e10)
  			//Ech./Ref.
  			m_pDoc->m_fT[i][3]=m_pDoc->m_fT[i][2]/m_pDoc->m_fT[i][1];
  		else
  			m_pDoc->m_fT[i][3]=1e10;
  	}		
	}
	m_pDoc->m_OKRendement=m_OKRendement;

	//Initialiser coordonnes souris__________________
	m_pDoc->m_fDx=0;m_pDoc->m_fDy=0;

	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}
//________________________________________
void CSelGrDlg::OnCalcul() 
{
	GetDlgItem(IDC_DENSITE)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FACT)->EnableWindow(TRUE);        
	GetDlgItem(IDC_BIREF)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FFT)->EnableWindow(TRUE);        
	UpdateData(TRUE);
	if (m_OKCalcul)
	{
		switch (m_pDoc->m_radioTypeAcq)
		{
			case 2://Densit
				GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
			break;	 
			case 3://Birfringence
				GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
			break;	 
		}
	}
	else
	{
		GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
	}
}
//________________________________________
void CSelGrDlg::OnCancel() 
{
	GetDlgItem(IDC_DENSITE)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FACT)->EnableWindow(TRUE);        
	GetDlgItem(IDC_BIREF)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FFT)->EnableWindow(TRUE);        
	CDialog::OnCancel();
}
//________________________________________
void CSelGrDlg::OnFft() 
{
	//Si on clique sur FFT, la superposition des graphes n'est pas possible
	//On dcoche rfrence et chantillon
	GetDlgItem(IDC_DENSITE)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FACT)->EnableWindow(TRUE);        
	UpdateData(TRUE);
	m_OKRef=FALSE;
	m_OKEchan=FALSE;  
	UpdateData(FALSE);
	GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
	GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
}
//________________________________________
void CSelGrDlg::OnRef() 
{
	//Si on clique sur rfrence, FFT ne peut pas tre valide
	GetDlgItem(IDC_DENSITE)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FACT)->EnableWindow(TRUE);        
	GetDlgItem(IDC_BIREF)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FFT)->EnableWindow(TRUE);        

	UpdateData(TRUE);
	//On valide birfringence
	m_radioBiref=0;
	UpdateData(FALSE);
	if (m_OKCalcul)
	{
		switch (m_pDoc->m_radioTypeAcq)
		{
			case 2://Densit
				GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
			break;	 
			case 3://Birfringence
				GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
			break;	 
		} 
	} 
	else
	{
		GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
	}
}
//________________________________________
void CSelGrDlg::OnEch() 
{
	//Si on clique sur chantillon, FFT ne peut pas tre valide
	GetDlgItem(IDC_DENSITE)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FACT)->EnableWindow(TRUE);        
	GetDlgItem(IDC_BIREF)->EnableWindow(TRUE);        
	GetDlgItem(IDC_FFT)->EnableWindow(TRUE);        
	
	UpdateData(TRUE);
	//On valide birfringence
	m_radioBiref=0;
	UpdateData(FALSE);
	if (m_OKCalcul)
	{
		switch (m_pDoc->m_radioTypeAcq)
		{
			case 2://Densit
				GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
			break;	 
			case 3://Birfringence
				GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
				GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
			break;	 
		} 
	} 
	else
	{
		GetDlgItem(IDC_BIREF)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FFT)->EnableWindow(FALSE);        
		GetDlgItem(IDC_DENSITE)->EnableWindow(FALSE);        
		GetDlgItem(IDC_FACT)->EnableWindow(FALSE);        
	}
}
