// SigGrDlg.cpp : implementation file
#include "stdafx.h"
#include "Bk.h"
#include "SigGrDlg.h"
#include "BkDoc.h"
#include <math.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
//________________________________________
// CSigGrDlg dialog
CSigGrDlg::CSigGrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSigGrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSigGrDlg)
	m_radioTypeGr = -1;
	m_OKRendement = FALSE;
	m_s1 = _T("");
	//}}AFX_DATA_INIT
}
void CSigGrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSigGrDlg)
	DDX_Radio(pDX, IDC_GR1, m_radioTypeGr);
	DDX_Check(pDX, IDC_RENDEMENT2, m_OKRendement);
	DDX_Text(pDX, IDC_STATIC1, m_s1);
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CSigGrDlg, CDialog)
	//{{AFX_MSG_MAP(CSigGrDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
//________________________________________
// CSigGrDlg message handlers
BOOL CSigGrDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	m_pApp=(CBkApp*)AfxGetApp();
	m_iNo=m_pApp->m_iNo;
	m_pDoc=m_pApp->m_pDocument[m_iNo];
	if (m_pDoc->m_iTypeGr & 16) m_radioTypeGr=1; else m_radioTypeGr=0;	
	m_OKRendement=m_pDoc->m_OKRendement;
	UpdateData(FALSE);
	return TRUE;
}
//________________________________________
void CSigGrDlg::OnCancel() 
{
	CDialog::OnCancel();
}
//________________________________________
void CSigGrDlg::OnOK() 
{
  short i;       
  float lambda,r,r1;
	UpdateData(TRUE);

	if (m_pDoc->m_OKRendement!=m_OKRendement)
	{
		//Il faut recalculer la deuxime colonne
	  for (i=0;i<m_pDoc->m_iNb;i++)
		{
			if (m_pDoc->m_fT[i][0]!=1e10 && m_pDoc->m_fT[i][1]!=1e10)
			{
				lambda=(float)(1E6/m_pDoc->m_fT[i][0]);
				r=m_pDoc->Sensibilite(lambda)*m_pDoc->Efficacite(lambda);
				if (m_OKRendement)
					m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]/r;
				else
					m_pDoc->m_fT[i][1]=m_pDoc->m_fT[i][1]*r;
			}	
		}
	} 
	m_pDoc->m_OKRendement=m_OKRendement;

	if (m_radioTypeGr==1) 
	{
		m_pDoc->m_iTypeGr=16; 
		//Calcul FFT
	  for (i=0;i<m_pDoc->m_iNb;i++)
  	{
			//Affectation partie relle FFT en colonne 3
  		if (m_pDoc->m_fT[i][0]!=0 && m_pDoc->m_fT[i][1]!=1e10)
  			m_pDoc->m_fT[i][3]=m_pDoc->m_fT[i][1];
  		else
  			m_pDoc->m_fT[i][3]=0; //Nul si division par zro
			//Affectation partie imaginaire FFT en colonne 4
    	m_pDoc->m_fT[i][4]=0;		//Partie imaginaire nulle
    }
		//Calcul FFT   
		m_s1="Calcul FFT en cours. Patientez...";
		UpdateData(FALSE);
		int nb;
		//Nb. d'chantillons multiple de 256...
		if (m_pDoc->m_iNb>=1000)
		{
			nb=1024;
			//On complte ventuellement  1024
			for (i=m_pDoc->m_iNb;i<1024;i++)
			{
  			m_pDoc->m_fT[i][3]=0;
	    	m_pDoc->m_fT[i][4]=0;
			}
		}
		if (m_pDoc->m_iNb>=512 && m_pDoc->m_iNb<1000) nb=512;
		if (m_pDoc->m_iNb>=256 && m_pDoc->m_iNb<512) nb=256;
		if (m_pDoc->m_iNb<256) 
		{
			nb=256;
			//On complte ventuellement  256
			for (i=m_pDoc->m_iNb;i<256;i++)
			{
  			m_pDoc->m_fT[i][3]=0;
	    	m_pDoc->m_fT[i][4]=0;
			}
		}	
		if (m_pDoc->FFTRap(m_pDoc->m_fT,&nb)==TRUE)
		{
			//Calcul module en colonne 4
			for (i=0;i<nb;i++)
			{
				m_pDoc->m_fT[i][4]=(float)(sqrt(pow(m_pDoc->m_fT[i][3],2)+pow(m_pDoc->m_fT[i][4],2)));
			}
			//Graduation colonne 3 en delta en tenant compte plage souhaite
			for (i=0;i<nb;i++)
			{
				m_pDoc->m_fT[i][3]=(float)(1/m_pDoc->m_fPasSigma-i/((nb-1)*m_pDoc->m_fPasSigma));
				//m_pDoc->m_fT[i][3]=(float)(i/m_pDoc->m_fPasSigma);
			}
			//Ecriture ordre inverse sur 100 points 
			short k=0;
			for (i=nb-1;i>nb-1-100;i--)
			{
				r=m_pDoc->m_fT[i][3];
				r1=m_pDoc->m_fT[i][4];
				m_pDoc->m_fT[k][3]=r;
				m_pDoc->m_fT[k][4]=r1;
				k++;
			} 
			
			//Limitation sur les 100 premiers points...  
			for (i=100;i<m_pDoc->m_iNb;i++)
			{
				m_pDoc->m_fT[i][3]=1e10;
				m_pDoc->m_fT[i][4]=1e10;
			} 
			
		}
	}	
	else 
		m_pDoc->m_iTypeGr=0;	

	//Initialiser coordonnes souris__________________
	m_pDoc->m_fDx=0;m_pDoc->m_fDy=0;

	m_pDoc->UpdateAllViews(NULL);
	CDialog::OnOK();
}
